'     =============== ALGEBRA LINEAR COMPUTACIONAL - VERSAO 1.0 ==============
'              Este programa calcula inversa, determinante e  escalona  matri-
'     zes de quaisquer ordem. Se a matriz for de ordem  3 x 3, 4 x 4 ou  5 x 5
'     entao sao calculados os polinomios minimo e caracteristico, os autovalo-
'     res,  os autovetores reais e a forma de Jordan da matriz.
'              Devido ao seu tamanho, o programa esta' dividido em  2  partes:
'     AL1.BAS (59.371 bytes) e AL2.BAS (44.087 bytes). Ha' uma versao compila-
'     da dessas duas partes chamada AL.EXE (134.257 bytes).
'              Foi elaborado na UFPB no primeiro semestre de  1989  como parte
'     de um projeto financiado pelo CNPQ.
'              A linguagem utilizada e' o Turbo-BASIC.
'     ========================================================================

'     ============================== AL1.BAS =================================

$dynamic
defint a - z
erro1# = 0.0001 : erro2# = 0.0000000001 : erro3# = 0.000001
dim ImpRz$(5), ImpRe$(2), ImpIm$(2), ImpSoma$(2), impr$(6)
dim expo(5), min(5), RzRe#(5), PtIm#(2), PtRe#(2), v#(5,5)
dim a$(5,5), mat#(5,5,5), coef#(6), cf#(6), autov$(5,5)
call TelaInicial
if ucase$(inicio$) = "E" then                               ' ajuste dos erros
  cls : locate 2,1 : print string$(79,196)
  locate 2,37 : print " ERROS "
  locate 4,6
  print "        Para manter os valores de erro1, erro2 ou erro3 apresentados"
  print spc(5); "abaixo, basta teclar <ENTER>."
  locate 7,6
  print "        No c"; chr$(160); "lculo dos autovalores, se X for um intei";
  print "ro, entao todos" : print spc(5);
  print "os n"; chr$(163); "meros do intervalo  [ X - erro1 , X + erro1 ] ";
  print " sao considerados" : print spc(5);
  print "id"; chr$(136); "nticos a X. O valor atual de erro1 "; chr$(130);
  print " 0.0001." : print spc(5);
  print "Forne"; chr$(135); "a o novo valor de erro1 : "; : input "", erro1#
  if erro1# = 0 then erro1# = 0.0001
  locate 12,6
  print "        Os autovalores sao calculados com um erro2  cujo valor atual"
  print spc(5); chr$(130); " de 0.0000000001."
  print spc(5);
  print "Forne"; chr$(135); "a o novo valor de erro2 : "; : input "", erro2#
  if erro2# = 0 then erro2# = 0.0000000001
  locate 16,6
  print "        Na determina"; chr$(135); "ao do  polinomio m"; chr$(161);
  print "nimo  ser"; chr$(160); " considerada  nula"
  print spc(5);
  print "toda matriz cuja soma dos m"; chr$(162); "dulos dos elementos for";
  print " menor que erro3." : print spc(5); "No c"; chr$(160); "lculo da ";
  print "nulidade, ser"; chr$(160);
  print " considerada nula toda linha  cuja  soma" : print spc(5);
  print "dos  m"; chr$(162); "dulos dos elementos  for  menor que erro3. ";_
        "O  valor atual  de"
  print spc(5); "erro3 "; chr$(130); " 0.000001."
  print spc(5); "Forne"; chr$(135); "a o novo valor de erro3 : ";
  input "", erro3# : if erro3# = 0 then erro3# = 0.000001
end if

PontoDeReferencia1:
Lval$ = "nao" : Linv$ = "nao" : Ldet$ = "nao" : Ldet$ = "nao" : Lnul$ = "nao"
Lmin$ = "nao" : Lvet$ = "nao" : Lesc$ = "nao" : Lsem$ = "nao" : Lpot$ = "nao"
car$ = "nao" : min$ = "nao" : eq$ = "nao"  : Ljor$ = "nao" : ImpM$ = "nao"
gr = 0 : vez = 1 : ExpoMin$ = "" : ExpoComplex$ = "" : Lcar$ = "nao"
call ModoDeEntrada
if opcao = 2 then call Le else call Entrada(vez)
PontoDeReferencia2:
cls : inversa$ = "nao" : troca$ = "sim" : grava$ = "nao"

if m = n and ( m >= 3 and m <= 5 ) then                               ' caso 1
  linha = 1 + int((7 - m)/2)
  call Mostra(a#(),m,n,1,n,linha)
  call Menu1
  select case opcao
    case 1
      call Moldura : troca$ = "nao"
      call Mostra(a#(),m,n,1,n,6)
      locate 13,27 : print " POLINOMIO CARACTERISTICO "
      if car$ = "nao" then call PolinomioCaracteristico(a#(),m)
      gosub IgualaMatrizes : car$ = "sim"
      for i = 2 to m + 1
        call FormataImpressao(coef#(i)) : impr$(i) = formato$
      next i
      call ImpPolCar(m,coef#(),impr$())
    case 2
      call Moldura : troca$ = "nao"
      call Mostra(a#(),m,n,1,n,6)
      locate 13,34 : print " AUTOVALORES "  : g = m
      if car$ = "nao" then call PolinomioCaracteristico(a#(),g)
      gosub IgualaMatrizes : car$ = "sim"
      if eq$ = "nao" then call ResolveEquacao(cf#(),g,erro1#,erro2#)
      eq$ = "sim"
      for i = 1 to re
        call FormataImpressao(RzRe#(i)) : ImpRz$(i) = "#" + formato$
      next i
      for i = 1 to complex
        call FormataImpressao(PtRe#(i)) : ImpRe$(i) = "#" + formato$
        call FormataImpressao(PtIm#(i)) : ImpIm$(i) = "#" + formato$
      next i
      posicao = 15
      for i = 1 to re
        for j = 1 to expo(i)
          locate posicao,38 : print using ImpRz$(i); RzRe#(i)
          posicao = posicao + 1
        next j
      next i
      for k = 1 to complex
        locate posicao,38 : sinal$ = " +"
        call ImprComplex(k,PtRe#(),PtIm#(),ImpRe$(),ImpIm$(),sinal$)
        posicao = posicao + 1 : sinal$ = " -"
        locate posicao,38
        call ImprComplex(k,PtRe#(),PtIm#(),ImpRe$(),ImpIm$(),sinal$)
        posicao = posicao + 1
      next k
    case 3
      call Moldura  : inversa$ = "sim" : grava$ = "sim"
      call Mostra(b#(),m,n,1,n,6)
      locate 13,30 : print " MATRIZ INVERSA DE M "
      call Inv(a#(),m)
      if v = 0 then
        locate 17,28 : print "A matriz nao tem inversa"
      else
        call Mostra(a#(),m,n,n + 1,2*n,14)
      end if : gr = 1
    case 4
      call Moldura : troca$ = "nao"
      call Mostra(b#(),m,n,1,n,6)
      call Det(a#(),m)
      call FormataImpressao(determinante#)
      locate 17,34 : print "det M = "; using "###" + formato$; determinante#
    case 5
      call Escalona(a#(),m,n,opcao,erro3#,x2$) : troca$ = "nao"
      call Moldura
      call Mostra(b#(),m,n,1,n,6)
      locate 16,32 : print "nulidade de M = " nulidade
      locate 17,32 : print "posto de M = " m - nulidade
    case 6
      call Moldura : troca$ = "nao"
      call Mostra(a#(),m,n,1,n,6)                                       ' C
      locate 13,31 : print " POLINOMIO MINIMO " : g = m
      if car$ = "nao" then call PolinomioCaracteristico(a#(),g)         ' A
      gosub IgualaMatrizes : car$ = "sim"
      if eq$ = "nao" then call ResolveEquacao(cf#(),g,erro1#,erro2#)    ' L
      eq$ = "sim"
      for i = 1 to re                                                   ' C
        call FormataImpressao(RzRe#(i)) : ImpRz$(i) = formato$
      next i                                                            ' U							
      for i = 1 to complex
        call FormataImpressao(PtRe#(i)) : ImpRe$(i) = formato$          ' L
        call FormataImpressao(PtIm#(i)) : ImpIm$(i) = formato$
        SomaCx# = PtRe#(i)^2 + PtIm#(i)^2                               ' O
        call FormataImpressao(SomaCx#) : ImpSoma$(i) = formato$
      next i
      if min$ = "nao" then
        CalculoDoPolinomioMinimo:
        if re < m then
          if complex = 0 then                                           ' D
            select case re
              case 1                                                    ' O
                for i1 = 1 to expo(1)
                  gosub UmaRaizReal
                  quant = i1
                  call ProdMat(mat#(),a#(),m,quant,x1$)
                  if soma# < erro3# then                                ' P
                    min(1) = i1
                    if opcao = 11 then goto RetornoDoPolMin             ' O
                    exit select
                  end if                                                ' L
                next i1
              case 2                                                    ' N
                for i1 = 1 to expo(1)
                  for i2 = 1 to expo(2)                                 ' O
                    gosub UmaRaizReal
                    gosub DuasRaizesReais                               ' M
                    quant = i1 + i2
                    call ProdMat(mat#(),a#(),m,quant,x3$)               ' I
                    if soma# < erro3# then
                      min(1) = i1 : min(2) = i2                         ' 0
                      if opcao = 11 then goto RetornoDoPolMin
                      exit select
                    end if
                  next i2
                next i1
              case 3                                                    ' M
                for i1 = 1 to expo(1)
                  for i2 = 1 to expo(2)                                 ' I
                    for i3 = 1 to expo(3)
                      gosub UmaRaizReal                                 ' N									
                      gosub DuasRaizesReais
                      gosub TresRaizesReais                             ' I
                      quant = i1 + i2 + i3
                      call ProdMat(mat#(),a#(),m,quant,x4$)             ' M
                      if  soma# < erro3# then
                        min(1) = i1 : min(2) = i2 : min(3) = i3         ' O
                        if opcao = 11 then goto RetornoDoPolMin
                        exit select
                      end if
                    next i3
                  next i2
                next i1
              case 4
                for i1 = 1 to expo(1)
                  for i2 = 1 to expo(2)
                    for i3 = 1 to expo(3)
                      for i4 = 1 to expo(4)
                        gosub UmaRaizReal
                        gosub DuasRaizesReais
                        gosub TresRaizesReais
                        gosub QuatroRaizesReais
                        quant = i1 + i2 + i3 + i4
                        call ProdMat(mat#(),a#(),m,quant,x1$)
                        if soma# < erro3# then
                          min(1) = i1 : min(2) = i2 : min(3) = i3 :min(4)=i4
                          if opcao = 11 then goto RetornoDoPolMin
                          exit select
                        end if
                      next i4
                    next i3
                  next i2
                next i1
            end select
          else
            if CxDif$ = "sim" or re + 2 = m  then
              min(1) = 1 : min(2) = 1 : min(3) = 1
              if opcao = 11 then goto RetornoDoPolMin else exit select
            else
              if re = 1 and complex = 1 then
                for i1 = 1 to expo(1)
                  gosub UmaRaizReal
                  x = i1 + 1
                  gosub RaizesComplexas
                  quant = i1 + 1
                  call ProdMat(mat#(),a#(),m,quant,x3$)
                  if soma# < erro3# then
                    min(1) = i1
                    if opcao = 11 then goto RetornoDoPolMin else exit select
                  end if
                next i1
              else
                if re = 2 and complex = 1 then
                  for i1 = 1 to expo(1)
                    for i2 = 1 to expo(2)
                      gosub UmaRaizReal
                      gosub DuasRaizesReais
                      x = i1 +i2 + 1
                      gosub RaizesComplexas
                      quant = i1 + i2 + 1
                      call ProdMat(mat#(),a#(),m,quant,x2$)
                      if soma# < erro3# then
                        min(1) = i1 : min(2) = i2
                        if opcao =11 then goto RetornoDoPolMin else exit select
                      end if
                    next i2
                  next i1
                else
                  for t1 = 1 to 2
                    for x = 1 to t1
                      gosub RaizesComplexas
                    next x
                    if m = 4 then
                      quant = t1
                    else
                      for i = 1 to m
                        for j = 1 to m
                          if i = j then
                            mat#(t1 + 1,i,j) = a#(i,j) - RzRe#(1)
                          else
                            mat#(t1 + 1,i,j) = a#(i,j)
                          end if
                        next j
                      next i
                      quant = t1 + 1
                    end if
                    call ProdMat(mat#(),a#(),m,quant,x3$)
                    if soma# < erro3# then
                      if t1 = 1 then
                        min(1) = 1 : ExpoMin$ = ""
                      else
                        min(1) = 1 : ExpoMin$ = "2"
                      end if
                      if opcao = 11 then goto RetornoDoPolMin else exit select
                    end if
                  next t1
                end if
             end if
           end if
        end if
      else
        for i = 1 to re
          min(i) = 1
        next i
      end if
      if opcao = 11 then goto RetornoDoPolMin
    end if
      case 7
        call Moldura : troca$ = "nao"
        call Mostra(a#(),m,n,1,n,6)
        locate 13,34 : print " AUTOVETORES " : g = m
        if car$ = "nao" then call PolinomioCaracteristico(a#(),g)
        gosub IgualaMatrizes : car$ = "sim"
        if eq$ = "nao" then call ResolveEquacao(cf#(),g,erro1#,erro2#)
        eq$ = "sim"
        if re = 0 then
          locate 17,13 : print "Nao existem autovetores associados a";
          print " autovalores reais"
        end if
        if complex > 0 then
          locate 21,25 : print " EXISTEM AUTOVETORES COMPLEXOS "
        end if
        linha = 15
        for k = 1 to re
          for i = 1 to m
            for j = 1 to n
              if i = j then a#(i,j) = b#(i,j)-RzRe#(k) else a#(i,j) = b#(i,j)
            next j
          next i
          call Escalona(a#(),m,n,opcao,erro3#,x2$)
          call Autovetores(a#(),m)
          call FormataImpressao(RzRe#(k)) : ImpRz$ = "#" + formato$
          for i = 1 to QuantAutov
            for j = 1 to n
              call FormataImpressao(v#(i,j)) : autov$(i,j) = "#" + formato$
            next j
          next i
          call ImpAutovetores(RzRe#(k),QuantAutov,v#(),n,autov$(),linha, _
               ImpRz$,"tela")
          linha = l
        next k
    case 8
      call Escalona(a#(),m,n,opcao,erro3#,x2$)
      call Moldura : grava$ = "sim"
      call Mostra(b#(),m,n,1,n,6)
      locate 13,30 : print " MATRIZ M ESCALONADA "
      call Mostra(a#(),m,n,1,n,14)
    case 9
      gosub EntradaDeP
      if v <> 0 then
        call Moldura  : grava$ = "sim"
        call Mostra(b#(),m,n,1,n,6)
        locate 13,25 : print " UMA MATRIZ SEMELHANTE A M E' "
        call ProdMat(mz#(),a#(),m,3,x4$)
        call Mostra(a#(),m,n,1,n,14)
      end if
      erase p#,copia#,mz#
    case 10
      gosub ValorDeN
      if expo >= 0 and expo = int(expo) then
        call Moldura : grava$ = "sim"
        call Mostra(b#(),m,n,1,n,6)
        locate 13,36 : print " M ^ " expo
        gosub PotenciaDeM
        call Mostra(a#(),m,n,1,n,14)
      end if
    case 11
        call Moldura : troca$ = "nao"                                      ' C
        call Mostra(a#(),m,n,1,n,6)
        locate 13,32 : print " FORMA DE JORDAN " : g = m                   ' A
        if car$ = "nao" then call PolinomioCaracteristico(a#(),g)
        gosub IgualaMatrizes : car$ = "sim"                                ' L
        if eq$ = "nao" then call ResolveEquacao(cf#(),g,erro1#,erro2#)
        eq$ = "sim"                                                        ' C
        if min$ = "nao" then
          goto CalculoDoPolinomioMinimo                                    ' U
          RetornoDoPolMin:
          call Classifica(expo(),min(),RzRe#(),re)                         ' L
          min$ = "sim"
        end if                                                             ' O
        for i = 1 to n
          for j = 1 to n
            a$(i,j) = ""
          next j
        next i                                                             ' D
        TotRe = 0
        for i = 1 to re                                                    ' A
          TotRe = TotRe + expo(i)
        next i
        select case n
          case 3                                                           ' F
            if re = 1 then
              if complex > 0 then                                          ' O
                a$(1,1) = str$(RzRe#(1))
                a$(2,2) = "x1" : a$(3,3) = "x2"                            ' R
              else
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))        ' M
                a$(3,3) = str$(RzRe#(1))
                if min(1) >= 2 then a$(1,2) = "1"                          ' A
                if min(1) = 3 then a$(2,3) = "1"
              end if
            elseif re = 2 then
              a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))          ' D
              a$(3,3) = str$(RzRe#(2))
              if min(1) = 2 then a$(1,2) = "1"                             ' E
            elseif re = 3 then
              a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(2))
              a$(3,3) = str$(RzRe#(3))
            end if                                                         ' J
          case 4
            if complex = 2 then                                            ' O
              if CxDif$ = "sim" then                                       							
                a$(1,1) = "x1" : a$(2,2) = "x2"                            ' R
                a$(3,3) = "x3" : a$(4,4) = "x4"
              else                                                         ' D
                a$(1,1) = "x1" : a$(2,2) = "x1"
                a$(3,3) = "x2" : a$(4,4) = "x2"                            ' A
                if ExpoMin$ = "2" then
                  a$(1,2) = "1" : a$(3,4) = "1"                            ' N
                end if
              end if
            end if
            if re = 1 then
              if complex > 0 then
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                a$(3,3) = "x1" : a$(4,4) = "x2"
                if min(1) = 2 then a$(1,2) = "1"
              else
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                a$(3,3) = str$(RzRe#(1)) : a$(4,4) = str$(RzRe#(1))
                if min(1) >= 2 then a$(1,2) = "1"
                if min(1) >= 3 then a$(2,3) = "1"
                if min(1) = 4 then a$(3,4) = "1"
                if min(1) = 2 then
                  for i = 1 to n
                    for j = 1 to n
                      if i=j then a#(i,j)=b#(i,j)-RzRe#(1) else a#(i,j)=b#(i,j)
                    next j
                  next i
                  call Escalona(a#(),m,n,opcao,erro3#,x2$)
                  if nulidade = 2 then a$(3,4) = "1"
                end if
              end if
            end if
            if re = 2 then
              if complex > 0 then
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(2))
                a$(3,3) = "x1" : a$(4,4) = "x2"
              else
                if expo(1) = 2 and expo(2) = 2 then
                  a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                  a$(3,3) = str$(RzRe#(2)) : a$(4,4) = str$(RzRe#(2))
                  if min(1) = 2 then a$(1,2) = "1"
                  if min(2) = 2 then a$(3,4) = "1"
                elseif expo(1) = 3 and expo(2) = 1 then
                  a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                  a$(3,3) = str$(RzRe#(1)) : a$(4,4) = str$(RzRe#(2))
                  if min(1) >= 2 then a$(1,2) = "1"
                  if min(1) = 3 then a$(2,3) = "1"
                end if
              end if
            end if
            if re = 3 then
              a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
              a$(3,3) = str$(RzRe#(2)) : a$(4,4) = str$(RzRe#(3))
              if min(1) = 2 then a$(1,2) = "1"
            end if
            if re = 4 then
              a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(2))
              a$(3,3) = str$(RzRe#(3)) : a$(4,4) = str$(RzRe#(4))
            end if
          case 5
            if complex = 2 then
              a$(1,1) = str$(RzRe#(1))
              if CxDif$ = "sim" then
                a$(2,2) = "x1" : a$(3,3) = "x2"
                a$(4,4) = "x3" : a$(5,5) = "x4"
              else
                a$(2,2) = "x1" : a$(3,3) = "x1"
                a$(4,4) = "x2" : a$(5,5) = "x2"
                if ExpoMin$ = "2" then a$(2,3) = "1" : a$(4,5) = "1"
              end if
            end if
            if re = 1 and complex < 2 then
              if complex > 0 then
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                a$(3,3) = str$(RzRe#(1)) : a$(4,4) = "x1" : a$(5,5) = "x2"
                if min(1) >= 2 then a$(1,2) = "1"
                if min(1) = 3 then a$(2,3) = "1"
              else
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                a$(3,3) = str$(RzRe#(1)) : a$(4,4) = str$(RzRe#(1))
                a$(5,5) = str$(RzRe#(1))
                if min(1) >= 2 then a$(1,2) = "1" else exit select
                if min(1) >= 3 then a$(2,3) = "1"
                if min(1) = 5 then a$(4,5) = "1"
                if min(1) >= 4 then a$(3,4) = "1" : exit select
                for i = 1 to n
                  for j = 1 to n
                    if i=j then a#(i,j)=b#(i,j)-RzRe#(1) else a#(i,j) = b#(i,j)
                  next j
                next i
                call Escalona(a#(),m,n,opcao,erro3#,x2$)
                if min(1) = 2 and nulidade = 3 then a$(3,4) = "1"
                if min(1) = 3 and nulidade = 2 then a$(4,5) = "1"
              end if
            end if
            if re = 2 then
              if complex > 0 then
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                a$(3,3) = str$(RzRe#(2)) : a$(4,4) = "x1" : a$(5,5) = "x2"
                if min(1) = 2 then a$(1,2) = "1"
              else
                if expo(1) = 3 and expo(2) = 2 then
                  a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                  a$(3,3) = str$(RzRe#(1)) : a$(4,4) = str$(RzRe#(2))
                  a$(5,5) = str$(RzRe#(2))
                  if min(2) = 2 then a$(4,5) = "1"
                  if min(1) >= 2 then a$(1,2) = "1"
                  if min(1) = 3 then a$(2,3) = "1"
                elseif expo(1) = 4 and expo(2) = 1 then
                  a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                  a$(3,3) = str$(RzRe#(1)) : a$(4,4) = str$(RzRe#(1))
                  a$(5,5) = str$(RzRe#(2))
                  if min(1) >= 2 then a$(1,2) = "1" else exit select
                  if min(1) = 4 then a$(3,4) = "1"
                  if min(1) >= 3 then a$(2,3) = "1" : exit select
                  if min(1) = 2 then
                    for i = 1 to n
                      for j = 1 to n
                        if i = j then a#(i,j) = b#(i,j) - RzRe#(1) _
                          else a#(i,j) = b#(i,j)
                      next j
                    next i
                    call Escalona(a#(),m,n,opcao,erro3#,x2$)
                    if nulidade = 2 then a$(3,4) = "1"
                  end if
                end if
              end if
            end if
            if re = 3 then
              if complex > 0 then
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(2))
                a$(3,3) = str$(RzRe#(3)) : a$(4,4) = "x1" : a$(5,5) = "x2"
              elseif expo(1) = 3 and expo(2) = 1 and expo(3) = 1 then
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                a$(3,3) = str$(RzRe#(1)) : a$(4,4) = str$(RzRe#(2))
                a$(5,5) = str$(RzRe#(3))
                if min(1) >= 2 then a$(1,2) = "1"
                if min(1) = 3 then a$(2,3) = "1"
              elseif expo(1) = 2 and expo(2) = 2 and expo(3) = 1 then
                a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
                a$(3,3) = str$(RzRe#(2)) : a$(4,4) = str$(RzRe#(2))
                a$(5,5) = str$(RzRe#(3))
                if min(1) = 2 then a$(1,2) = "1"
                if min(2) = 2 then a$(3,4) = "1"
              end if
            end if
            if re = 4 then
              a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(1))
              a$(3,3) = str$(RzRe#(2)) : a$(4,4) = str$(RzRe#(3))
              a$(5,5) = str$(RzRe#(4))
              if min(1) = 2 then a$(1,2) = "1"
            elseif re = 5 then
              a$(1,1) = str$(RzRe#(1)) : a$(2,2) = str$(RzRe#(2))
              a$(3,3) = str$(RzRe#(3)) : a$(4,4) = str$(RzRe#(4))
              a$(5,5) = str$(RzRe#(5))
            end if
        end select
        call ImpJordan(a$(),n,re,RzRe#(),TotRe,"tela")
    case 12
      call Grava(a#(),m,n,gr)
    case 13
      erase a#, b#
      goto PontoDeReferencia1
    case 14
      call Informacoes
      goto PontoDeReferencia2
    case 15
      call Mensagem(x1$,x2$,x3$,x4$)
  end select
  if opcao = 6 then
    call Classifica(expo(),min(),RzRe#(),re)
    call ImprMin(re,RzRe#(),min(),ImpRz$(),complex,CxDif$,PtRe#(),PtIm#(),_
         ImpRe$(),ImpIm$(),ImpSoma$(),"m",ExpoMin$)
    min$ = "sim"
    diag$ = "sim"
    for i = 1 to re
      if min(i) <> 1 then diag$ = "nao"
    next i
    if complex = 2 and ExpoMin$ = "2" then diag$ = "nao"
    if diag$ = "sim" then
      locate 21,27 : print " A MATRIZ E' DIAGONALIZAVEL "
    end if
  end if
end if

if m = n and ( m > 5 or m < 3 ) then                                  ' caso 2
  linha = int((17 - m)/2) + 1
  call Mostra(a#(),m,n,1,n,linha)
  call Menu2
  select case opcao
    case 1
      cls : inversa$ = "sim"
      call Inv(a#(),m)
      if v = 0 then
        locate 12,30
        print "A matriz nao tem inversa"
      else
        print string$(79,196)
        locate 1,30 : print " MATRIZ INVERSA DE M "
        call Mostra(a#(),m,n,n + 1,2*n,linha + 4)
        grava$ = "sim"
      end if
      gr = 1
    case 2
      call Det(a#(),m)
      cls : troca$ = "nao"
      call FormataImpressao(determinante#)
      locate 12,35 : print "det M = "; using "####" + formato$; determinante#
    case 3
      gosub ValorDeN
      if expo >= 0 and expo = int(expo) then
        gosub PotenciaDeM
        grava$ = "sim" : cls : print string$(79,196)
        locate 1,37 : print " M ^ "; expo
        print
        call Mostra(a#(),m,n,1,n,linha + 4)
      end if
    case 4
      cls  : troca$ = "nao"
      call Escalona(a#(),m,n,opcao,erro3#,x2$)
      locate 12,32 : print "nulidade de M = " nulidade
      locate 13,32 : print "posto de M = " m - nulidade
    case 5
      call Escalona(a#(),m,n,opcao,erro3#,x2$)
      cls : grava$ = "sim" : print string$(79,196)
      locate 1,30 : print " MATRIZ M ESCALONADA "
      call Mostra(a#(),m,n,1,n,linha + 4)
    case 6
      gosub EntradaDeP
      if v <> 0 then
        call ProdMat(mz#(),a#(),m,3,x3$)
        cls : grava$ = "sim" : print string$(79,196)
        locate 1,26 : print " UMA MATRIZ SEMELHANTE A M E' "
        call Mostra(a#(),m,n,1,n,linha + 4) : erase mz#
      end if
      erase p#,copia#,mz#
    case 7
      call Grava(a#(),m,n,gr)
    case 8
      erase a#,b#  : vez = 1
      goto PontoDeReferencia1
    case 9
      call Informacoes
      goto PontoDeReferencia2
    case 0
      call Mensagem(x1$,x2$,x3$,x4$)
  end select
end if

if m <> n then                                                        ' caso 3
  linha = int((19 - m)/2) + 1
  call Mostra(a#(),m,n,1,n,linha)
  call Menu3
  select case opcao
    case 1
      call Escalona(a#(),m,n,opcao,erro3#,x2$)
      cls : grava$ = "sim" : print string$(79,196)
      locate 1,25 : print " MATRIZ M ESCALONADA "
      call Mostra(a#(),m,n,1,n,6)
    case 2
      call Grava(a#(),m,n,gr)
    case 3
      erase a#,b# : vez = 1
      goto PontoDeReferencia1
    case 4
      call Mensagem(x1$,x2$,x3$,x4$)
  end select
end if

fim$ = input$(1)

if ucase$(fim$) = "I" then                 ' impressao dos resultados no papel
  if ImpM$ = "nao" then
    lprint : lprint
    call Separa(" MATRIZ M ","=")
    call Lmostra(b#(),m,n,1,n)
    ImpM$ = "sim"
  end if
  if m = n and m <= 5 and m >= 3 then
    select case opcao
      case 1
        if Lcar$ = "nao" then
          call Separa(" POLINOMIO CARACTERISTICO ","-")
          call LImpPolCar(m,coef#(),impr$()) : Lcar$ = "sim"
        end if
      case 2
        if Lval$ = "nao" then
          call Separa(" AUTOVALORES ","-")
          for i = 1 to re
            for j = 1 to expo(i)
              lprint spc(38); using ImpRz$(i); RzRe#(i)
            next j
          next i
          for i = 1 to complex
            call LImprComplex(i,PtRe#(),PtIm#(),ImpRe$(),ImpIm$()," +")
            call LImprComplex(i,PtRe#(),PtIm#(),ImpRe$(),ImpIm$()," -")
          next i  : Lval$ = "sim"
        end if
      case 3
        if Linv$ = "nao" then
          call Separa(" MATRIZ INVERSA DE M ","-")
          if v = 0 then
            lprint spc(26); " A matriz nao tem inversa "
          else
            call Lmostra(a#(),m,n,n + 1,2*n)
          end if : Linv$ = "sim"
        end if
      case 4
        if Ldet$ = "nao" then
          call Separa(" DETERMINANTE ","-") : Ldet$ = "sim"
          lprint spc(38); using "###" + formato$; determinante#
        end if
      case 5
        if Lnul$ = "nao" then
          call Separa(" NULIDADE ","-")
          lprint spc(38); nulidade
          call Separa(" POSTO ","-")
          lprint spc(38); m - nulidade  : Lnul$ = "sim"
        end if
      case 6
        if Lmin$ = "nao" then
          call Separa(" POLINOMIO MINIMO ","-") : Lmin$ = "sim"
          call LImprMin(re,RzRe#(),min(),ImpRz$(),complex,CxDif$,PtRe#(),_
               PtIm#(),ImpRe$(),ImpIm$(),ImpSoma$(),"m",ExpoMin$)
        end if
      case 7
        if Lvet$ = "nao" then
          call Separa(" AUTOVETORES ","-") : Lvet$ = "sim"
          for k = 1 to re
            for i = 1 to m
              for j = 1 to n
                if i = j then a#(i,j) = b#(i,j)-RzRe#(k) else a#(i,j) = b#(i,j)
              next j
            next i
            call Escalona(a#(),m,n,opcao,erro3#,x2$)
            call Autovetores(a#(),m)
            call FormataImpressao(RzRe#(k))
            ImpRz$ = "#" + formato$
            for i = 1 to QuantAutov
              for j = 1 to n
                call FormataImpressao(v#(i,j))
                autov$(i,j) = "#" + formato$
              next j
            next i
            call ImpAutovetores(RzRe#(k),QuantAutov,v#(),n,autov$(),linha, _
               ImpRz$,"papel")
            linha = l
          next k
          if complex > 0 then lprint : lprint "   Existem autovetores asso";_
              : lprint "ciados a autovalores complexos"
          if re = 0 then lprint  : lprint "   Nao existem autovetores asso";_
              : lprint "ciados a autovalores reais"
        end if
      case 8
        if Lesc$ = "nao" then
          call Separa(" MATRIZ M ESCALONADA ","-")
          call Lmostra(a#(),m,n,1,n) : Lesc$ = "sim"
        end if
      case 9
        if Lsem$ = "nao" then
          call Separa(" UMA MATRIZ SEMELHANTE A M E' ","-")
          call Lmostra(a#(),m,n,1,n) : Lsem$ = "sim"
        end if
      case 10
        if Lpot$ = "nao" then
          ex$ = " M ^" + str$(n) + " "
          call Separa(ex$,"-") : Lpot$ = "sim"
          call Lmostra(a#(),m,n,1,n)
        end if
      case 11
        if Ljor$ = "nao" then
          call Separa(" FORMA DE JORDAN ","-")
          call ImpJordan(a$(),n,re,RzRe#(),TotRe,"papel") : Ljor$ = "sim"
        end if
    end select
  end if
  if m = n and ( m > 5 or m < 3 ) then
    select case opcao
      case 1
        if Linv$ = "nao" then
          call Separa(" MATRIZ INVERSA DE M ","-")
          if v = 0 then
            lprint spc(26); "A matriz nao tem inversa"
          else
            call Lmostra(a#(),m,n,n + 1,2*n)
          end if : Linv$ = "sim"
        end if
      case 2
        if Ldet$ = "nao" then
          call Separa(" DETERMINANTE ","-") : Ldet$ = "sim"
          lprint spc(38); using "####" + formato$; determinante#
        end if
      case 3
        if Lpot$ = "nao" then
          ex$ = " M ^" + str$(n) + " "
          call Separa(ex$,"-") : Lpot$ = "sim"
          call Lmostra(a#(),m,n,1,m)
        end if
      case 5
        if Lesc$ = "nao" then
          call Separa(" MATRIZ M ESCALONADA ","-")
          call Lmostra(a#(),m,n,1,n) : Lesc$ = "sim"
        end if
      case 4
        if Lnul$ = "nao" then
          call Separa(" NULIDADE ","-")
          lprint spc(38); nulidade : Lnul$ = "sim"
          call Separa(" POSTO ","-")
          lprint spc(38); m - nulidade
        end if
      case 6
        if Lsem$ = "nao" then
          call Separa(" UMA MATRIZ SEMELHANTE A M E' ","-")
          call Lmostra(a#(),m,n,1,n) : Lsem$ = "sim"
        end if
    end select
  end if
  if m <> n then
    if opcao = 1 and Lesc$ = "nao" then
      call Separa(" MATRIZ M ESCALONADA ","-")
      call Lmostra(a#(),m,n,1,n) : Lesc$ = "sim"
    end if
  end if
end if

if ucase$(fim$) = "G" and grava$ = "sim" then               ' grava a matriz-
  call Grava(a#(),m,n,gr)                                   ' resultado    no
  x$ = input$(1)                                            ' disco
end if

if ucase$(fim$) = "F" and m = n and m >= 3 and m <= 5 and opcao = 1 then
  for i = 16 to 19
    locate i,11 : print space$(59)                        ' fatora o polinomio
  next i                                                  ' caracteristico
  gosub IgualaMatrizes : g = m
  if eq$ = "nao" then call ResolveEquacao(cf#(),g,erro1#,erro2#)
  eq$ = "sim"
  for i = 1 to re
    call FormataImpressao(RzRe#(i))
    ImpRz$(i) = formato$
  next i
  if complex = 2 and CxDif$ = "nao" then ExpoComplex$ = "2"
  for i = 1 to complex
    call FormataImpressao(PtRe#(i)) : ImpRe$(i) = formato$
    call FormataImpressao(PtIm#(i)) : ImpIm$(i) = formato$
    SomaCx# = PtRe#(i)^2 + PtIm#(i)^2
    call FormataImpressao(SomaCx#)  : ImpSoma$(i) = formato$
  next i
  call Classifica(expo(),min(),RzRe#(),re)
  call ImprMin(re,RzRe#(),expo(),ImpRz$(),complex,CxDif$,PtRe#(),PtIm#(),_
       ImpRe$(),ImpIm$(),ImpSoma$(),"p",ExpoComplex$)
  x$ = input$(1)
end if

if fim$ = "#" and troca$ = "sim" then                        ' troca a matriz-
  if inversa$ <> "sim" then                                  ' resultado  pela
    for i = 1 to m                                           ' matriz-proposta
      for j = 1 to 2*n
        b#(i,j) = a#(i,j)
      next j
    next i
  else
    for i = 1 to m
      for j = 1 to n
        b#(i,j) = a#(i,j + n)
      next j
      for j = n + 1 to 2*n
        b#(i,j) = a#(i,j - n)
      next j
    next i
  end if
  ImpM$ = "nao" : Lcar$ = "nao" : eq$ = "nao" : car$ = "nao" : Ljor$ = "nao"
  Lval$ = "nao" : Linv$ = "nao" : Ldet$ = "nao" : Ldet$ = "nao" : Lnul$ = "nao"
  Lmin$ = "nao" : Lvet$ = "nao" : Lesc$ = "nao" : Lsem$ = "nao" : Lpot$ = "nao"
  car$ = "nao" : min$ = "nao" : eq$ = "nao"  : min$ = "nao"
end if

if m >= 3 and m <=5 and m = n and opcao = 2 and ucase$(fim$) = "G" then
  locate 22,11 : print "Local onde ser";chr$(160); " gravado : "; : input "",x$
  open "o", #1, x$ + "autovalo.res"
    for i = 1 to re
      for j = 1 to expo(i)                           ' gravacao dos autovalores
        print #1, RzRe#(i)                           ' no disco
      next j
    next i
    for i = 1 to complex
      comp$ = str$(PtRe#(i)) + " " + chr$(241) + " " + str$(PtIm#(i)) + " i"
      print #1, comp$
    next i
  close #1
end if
              ' gravacao dos coeficientes do polinomio caracteristico no disco

if m >= 3 and m <= 5 and m = n and opcao = 1 and ucase$(fim$) = "G" then
  locate 22,11 : print "Local onde ser";chr$(160); " gravado : "; : input "",x$
  open "o", #2, x$ + "polinom.car"
    print #2, "   "
    print #2, "Coeficientes do polinomio caracteristico segundo as potencias"
    print #2, "decrescentes de 'x' : "  : print #2, "    "
    for i = 1 to n + 1
      print #2, coef#(i)
    next i
  close #2
end if

gr = 0
gosub IgualaMatrizes
goto PontoDeReferencia2

'-----------------------------------------------------------------------------

UmaRaizReal:                                          ' calculo da matriz mat#
gosub IgualaMatrizes
for q1 = 1 to i1
  for i = 1 to m
    for j = 1 to m
      if i = j then mat#(q1,i,j) = a#(i,j) -RzRe#(1) else mat#(q1,i,j)=a#(i,j)
    next j
  next i
next q1
return

DuasRaizesReais:
gosub IgualaMatrizes
for q2 = i1 + 1 to i1 + i2
  for i = 1 to m
    for j = 1 to m
      if i = j then mat#(q2,i,j) = a#(i,j) -RzRe#(2) else mat#(q2,i,j)=a#(i,j)
    next j
  next i
next q2
return

TresRaizesReais:
gosub IgualaMatrizes
for q3 = i1 + i2 + 1 to i1 + i2 + i3
  for i = 1 to m
    for j = 1 to m
      if i = j then mat#(q3,i,j) = a#(i,j) -RzRe#(3) else mat#(q3,i,j)=a#(i,j)
    next j
  next i
next q3
return

QuatroRaizesReais:
gosub IgualaMatrizes
for q4 = i1 + i2 + i3 + 1 to i1 + i2 + i3 + i4
  for i = 1 to m
    for j = 1 to m
      if i = j then mat#(q4,i,j) = a#(i,j) -RzRe#(4) else mat#(q4,i,j)=a#(i,j)
    next j
  next i
next q4
return

RaizesComplexas:
gosub IgualaMatrizes
for i = 1 to m
  for j = 1 to m
    mat#(x,i,j) = 0
    for k = 1 to m
      mat#(x,i,j) = mat#(x,i,j) + a#(i,k)*a#(k,j)
    next k
    if i = j then y = 1 else y = 0
    mat#(x,i,j) = mat#(x,i,j) - 2*PtRe#(1)*a#(i,j) + y*(PtRe#(1)^2+PtIm#(1)^2)
  next j
next i
return

IgualaMatrizes:
for i = 1 to m
  for j = 1 to 2*n
    a#(i,j) = b#(i,j)
  next j
next i
return

ValorDeN:
cls
locate 11,43 : print "n"
locate 12,30 : print "CALCULO DE M"
locate 14,30 : input "Valor de n: ", expo
cls
return

PotenciaDeM:
dim MatPot#(expo,m,n)
for q = 1 to expo
  for i = 1 to m
    for j = 1 to n
      MatPot#(q,i,j) = a#(i,j)
    next j
  next i
next q
call ProdMat(MatPot#(),a#(),m,expo,x2$)
erase MatPot#
return

EntradaDeP:
cls
locate 8,21 : print "SELECIONE O MODO DE ENTRADA DA MATRIZ P :"
locate 11,18 : print "1. A matriz P ser"; chr$(160);" introduzida pelo teclado"
locate 13,18 : print "2. A matriz P ser"; chr$(160);" lida no disco"
locate 15,18 : print "3. P "; chr$(130); " a matriz cujo termo geral  ";
print chr$(130); "   p    =  0 se i = j"
locate 16,18 : print "                                       ij"
locate 17,18 : print "   e  p   =  1 se i for diferente de j"
locate 18,18 : print "       ij "
op = val(input$(1))
dim copia#(m,2*n), p#(m,2*n), mz#(5,m,n)
for i = 1 to m
  for j = 1 to 2*n
    copia#(i,j) = b#(i,j)
  next j
next i
erase a#, b#
if op = 2 then
  call Le
elseif op = 1 then
  call Entrada(2)
elseif op <> 1 and op <> 2 then
  dim a#(m,2*n), b#(m,2*n)
  for i = 1 to m
    for j = 1 to n
      a#(i,j) = abs(sgn(i - j))
    next j
    for j = n + 1 to 2*n
      if j - i = n then a#(i,j) = 1 else a#(i,j) = 0
    next j
  next i
end if
for i = 1 to m
  for j = 1 to 2*n
    p#(i,j) = a#(i,j) : a#(i,j) = copia#(i,j)
    b#(i,j) = copia#(i,j) : copia#(i,j) = p#(i,j)
  next j
next i
call Inv(p#(),m)
if v = 0 then
  cls
  locate 12,30 : print "A matriz P nao tem inversa"
  return
end if
for i = 1 to m
  for j = 1 to n
    mz#(1,i,j) = p#(i,j + n) : mz#(2,i,j) = b#(i,j)
    mz#(3,i,j) = copia#(i,j)
  next j
next i
return

$segment

' ----------------------------------------------------------------------------

sub TelaInicial                                ' tela com o titulo do programa
  shared inicio$
  cls : key off
  locate 12,26 : print "ALGEBRA LINEAR COMPUTACIONAL"
  locate 9,10 : print string$(60,176)
  locate 15,10 : print string$(60,176)
  for i = 10 to 14
    locate i,10 : print string$(2,176)
    locate i,68 : print string$(2,176)
  next i
  inicio$ = input$(1)
end sub

sub ModoDeEntrada                               ' seleciona um modo de entrada
  shared opcao, x1$,x2$,x3$,x4$
  cls : locate 9,20
  print "SELECIONE O MODO DE ENTRADA DA MATRIZ ( 1 OU 2 ) :"
  locate 12,17
  print "1. A matriz ser"; chr$(160); " introduzida pelo teclado"
  locate 14,17
  print "2. A matriz ser"; chr$(160); " lida no disco"
  opcao = val(input$(1))
  x1$ = "Programa elaborado no 1" + chr$(167) + " semestre de 1989 por"
  x2$ = "Lenimar Nunes de Andrade"
  x3$ = "UFPB - CCEN - Departamento de Matem" + chr$(160) + "tica"
  x4$ = "58.059 - Joao Pessoa, PB"
end sub

sub Entrada(x)                                ' entrada da matriz pelo teclado
  shared m, n, a#(), b#()
  cls
  if x = 1 then
    m = 0 : n = 0
    while m*n = 0
      locate 2,10 : input "Quantidade de linhas da matriz : ", m
      if m > 0 then
        locate 4,10 : input "Quantidade de colunas da matriz : ", n
      end if
    wend
  end if
  locate 6,15 : print "Escreva a matriz no formato usual, teclando <ENTER> as";
  print "sim" : locate 7,10 : print "que for digitado cada elemento : "
  dim a#(m,2*n), b#(m,2*n)
  if m > 7 then b = 1 else b = 2
  print : print
  for i = 1 to m
    col = 25
    for j = 1 to n
      locate 9 + b*i, col
      input " ",x$
      l = len(x$)
      a#(i,j) = val(x$) : b#(i,j) = a#(i,j)
      for k = 1 to l
        if mid$(x$,k,1) = "/" then
          a#(i,j) = val(mid$(x$,1,k - 1))/val(mid$(x$,k + 1,l - k))
          b#(i,j) = a#(i,j)
        end if
      next k
      if a#(i,j) = 0 then locate 9 + b*i, col : print " 0"
      if a#(i,j) = 0 then col = col + 3 else col = col + 2 + len(x$)
    next j
  next i
  if m = n then
    for i = 1 to n
      for j = n + 1 to 2*n
        if j - i = n then a#(i,j) = 1 else a#(i,j) = 0
        b#(i,j) = a#(i,j)
      next j
    next i
  end if
end sub

sub Menu1                                                   ' menu de opcoes 1
  shared opcao
  for i = 2 to 21
    locate i,10 : print chr$(186)
    locate i,70 : print chr$(186)
  next i
  locate 1,10 : print chr$(201); string$(59,205); chr$(187)
  locate 9,10 : print chr$(204); string$(59,205); chr$(185)
  locate 22,10 : print chr$(200); string$(59,205); chr$(188)
  locate 1,36 : print " MATRIZ M "
  locate 22,15 : print " pressione as teclas que  correspondem ";chr$(133);
  print " sua op"; chr$(135); "ao " : locate 11,12
  print "01. Polin"; chr$(147); "mio         06. Polin";chr$(147);"mio";
  print spc(7); "11. Forma de" : locate 12,12
  print "    caracter"; chr$(161); "stico        m";chr$(161);"nimo"; spc(14);
  print "Jordan" : locate 14,12
  print "02. Autovalores       07. Autovetores     12. Grava"
  locate 16,12
  print "03. Inversa           08. Escalona        13. Nova Matriz"
  locate 17,12 : print "                           -1"
  locate 18,12
  print "04. Determinante      09. P  MP           14. Informa";chr$(135);"oes"
  locate 19,12 : print "                           n"
  locate 20,12 : print "05. Posto/nulidade    10. M               15. Fim"
  opcao = val(input$(2))
end sub

sub Menu2                                                   ' menu de opcoes 2
  shared opcao
  locate 1,1 : print string$(79,196)
  locate 1,35 : print " MATRIZ M "
  locate 18,1 : print chr$(218); string$(78,196); chr$(191);
  print chr$(179); " 1. Inversa"; spc(17); "4. Posto/nulidade";
  print spc(13); "7. Grava no disco"; spc(3); chr$(179);
  print chr$(179); " 2. Determinante"; spc(12); "5. Escalona     ";
  print spc(14); "8. Nova matriz"; spc(6); chr$(179);
  print chr$(179); "     n"; spc(26); "-1";spc(24);"9. Informa";chr$(135);"oes";
  print spc(6); chr$(179);
  print chr$(179); " 3. M"; spc(23); "6. P  MP"; spc(22); "0. Fim";
  print spc(14); chr$(179);
  locate 23,1 : print chr$(192); string$(78,196); chr$(217);
  opcao = val(input$(1))
end sub

sub Menu3                                                   ' menu de opcoes 3
  shared opcao
  locate 1,1 : print string$(79,196)
  locate 1,35 : print " MATRIZ M "
  locate 20,1 : print chr$(218); string$(78,196); chr$(191)
  locate 21,1 : print chr$(179); spc(5);
  print "1. Escalona          2. Grava         3. Nova matriz          4. Fim";
  print spc(5); chr$(179)
  locate 22,1 : print chr$(192); string$(78,196); chr$(217)
  opcao = val(input$(1))
end sub

sub Mostra(a#(2),m,n,col1,col2,horz)          ' apresentacao da matriz na tela
  shared espaco
  tipo = 1 : inteiro$ = "sim"
  for i = 1 to m
    for j = col1 to col2
      if a#(i,j) <> int(a#(i,j)) then inteiro$ = "nao"
      if abs(a#(i,j)) >= 100 then tipo = 2
      if abs(a#(i,j)) > 9999999.999 then call Final
    next j
  next i
  if inteiro$ = "sim" then
    if tipo = 1 then formimp$ = "####" else formimp$ = "#######"
    else
    if tipo = 1 then formimp$ = "####.####" else formimp$ = "#######.###"
  end if
  if len(formimp$) < 9 then
    espaco = 38 - n*int(len(formimp$)/2)
  else
    espaco = 36 - n*int(len(formimp$)/2)
  end if
  if espaco <= 0 then
    if m = n and m <= 5 then mens = horz + 2 else mens = 12
    locate mens,20
    print "Nao h"; chr$(160); " espa"; chr$(135); "o para impressao da matriz"
    exit sub
  end if
  if m = n and m <= 5 and m >= 3 then tipoimp = 1 else tipoimp = 2
  if tipoimp = 1 then
    locate horz,espaco
    print chr$(218); spc(n*len(formimp$) + 2); chr$(191)
  end if
  for i = 1 to m
    locate horz + i,espaco
    if tipoimp = 1 then print chr$(179);
    for j = col1 to col2
      print using formimp$; a#(i,j);
    next j
    if tipoimp = 1 then print "  " + chr$(179)
  next i
  if tipoimp = 1 then
    locate horz +  i,espaco
    print chr$(192); spc(n*len(formimp$) + 2); chr$(217);
  end if
end sub

sub Moldura                                           ' moldura dos resultados
  cls
  for i = 6 to 20
    locate i,10 : print chr$(186)
    locate i,70 : print chr$(186)
  next i
  locate 5,10 : print chr$(201); string$(59,205); chr$(187)
  locate 5,36 : print " MATRIZ M "
  locate 13,10 : print chr$(204); string$(59,205); chr$(185)
  locate 21,10 : print chr$(200); string$(59,205); chr$(188)
end sub

sub Le                                            ' leitura da matriz no disco
  shared a#(), b#(), m, n
  nome$ = "Guizinha"
  while nome$ = "Guizinha" or nome$ = "?"
    cls
    locate 1,1 : print "Local onde est"; chr$(160); " a matriz : ";
    input "", MatDrive$
    locate 3,1 : input "Nome da matriz ( sem a extensao .MAT ) : ", nome$
    if nome$ = "" then end
    if nome$ = "?" then
      locate 5,1 : print "Matrizes em " MatDrive$ : print : print
      diretorio$ = "dir " + MatDrive$ + "\*.mat|find "+chr$(34)+"MAT"+chr$(34)
      shell diretorio$
      locate 23,1 : input "Nome da matriz ( sem a extensao .MAT ) : ", nome$
      if nome$ = "" then end
    end if
  wend
  nome$ = matdrive$ + nome$ + ".mat"
  on error goto ErroDeLeitura
  open "i", #1, nome$
    input #1, m
    input #1, n  : if m*n <= 0 then end
    dim a#(m,2*n), b#(m,2*n)
    for i = 1 to m
      for j = 1 to n
        input #1, a#(i,j)
        b#(i,j) = a#(i,j)
      next j
    next i
  close #1
  if m = n then
    for i = 1 to n
      for j = n + 1 to 2*n
        if j - i = n then a#(i,j) = 1 else a#(i,j) = 0
        b#(i,j) = a#(i,j)
      next j
    next i
  end if
  FinalDaLeitura:
  on error goto 0
  exit sub
  ErroDeLeitura:
  cls : locate 12,15
  print "NO LOCAL ESPECIFICADO NAO EXISTE MATRIZ COM O NOME DADO"
  x$ = input$(1)  : m = 3 : n = 3 : dim a#(3,3), b#(3,3)
  resume FinalDaLeitura
end sub

sub Grava(a#(2),m,n,gr)                              ' grava a matriz no disco
  cls
  locate 9,20 : input "Nome da matriz a ser gravado no disco: ", nome$
  locate 12,34 : print "Gravando..."
  nome$ = nome$ + ".mat"
  open "o", #2, nome$
    write #2, m
    write #2, n
    if gr = 0 then
      col1 = 1 : col2 = n
    else
      col1 = n + 1 : col2 = 2*n
    end if
    for i = 1 to m
      for j = col1 to col2
        write #2, a#(i,j)
      next j
    next i
  close #2
  locate 15,20 : print "Para continuar pressione qualquer tecla "
end sub

sub Final                                               ' reinicio do programa
  cls : locate 12,20
  print "HA' NUMEROS MUITO GRANDES PARA SEREM IMPRESSOS"
  locate 15,20 : print "NAO HA' CONDICAO DE CONTINUAR COM ESSA MATRIZ"
  y$ = input$(1) : end
end sub

sub FormataImpressao(x#)           ' formata a impressao dos valores numericos
  shared formato$
  if abs(x#) > 9999999.999 then call Final
  if x# = int(x#) then
    if abs(x#) > 999 then
      formato$ = "#######"
    else
      if abs(x#) > 99 then
        formato$ = "###"
      else
        if abs(x#) > 9 then formato$ = "##" else formato$ = "#"
      end if
    end if
  else
    if abs(x#) > 999 then
      formato$ = "#######.####"
    else
      if abs(x#) > 99 then
        formato$ = "###.####"
      else
        if abs(x#) > 9 then formato$ = "##.####" else formato$ = "#.####"
      end if
    end if
  end if
end sub

sub ImpPolCar(grau,coef#(1),impr$(1))  ' impressao do polinomio caracteristico
  soma$ = "" : k = 0
  for i = 2 to grau + 1
    if coef#(i) <> 0 then
      soma$ = soma$ + impr$(i)
      if i < grau + 1 then k = k + 1
    end if
  next i
  ColImpPol = 7 + int(25 - 2*k - len(soma$)/2)
  if ColImpPol < 11 then ColImpPol = 11
  locate 16,ColImpPol
  print spc(8); using "#"; grau;
  for i = 2 to grau - 1
    if coef#(i) <> 0 then
      if abs(coef#(i)) <> 1 then
        print spc(5 + len(impr$(i))); using "#"; grau - i + 1;
      else
        print spc(5); using "#"; i;
      end if
    end if
  next i
  print
  locate 17,ColImpPol
  print "p(x) = x";
  for i = 2 to grau + 1
    if coef#(i) <> 0 then
      if pos(0) > 65 then locate 19,21
      if coef#(i) > 0 then print "  + "; else print "  - ";
      if abs(coef#(i)) <> 1 or i=grau+1 then
        if pos(0) + len(impr$(i)) > 69 then locate 19,21
        print using impr$(i);abs(coef#(i));
      end if
      if i <=  grau then
        if pos(0) > 67 then locate 19,21
        print " x";
      end if
    end if
  next i
end sub
                                         ' impressao dos autovalores complexos

sub ImprComplex(k,PtRe#(1),PtIm#(1),ImpRe$(1),ImpIm$(1),sinal$)
  if PtRe#(k) <> 0 then
    print using ImpRe$(k); PtRe#(k);
    if PtIm#(k) = 1 then
      print sinal$ + " i"
    else
      print sinal$;
      print using ImpIm$(k); PtIm#(k);
      print " i"
    end if
  else
    print spc(len(ImpRe$));
    if PtIm#(k) = 1 then
      if sinal$ = " -" then print sinal$; else print "  ";
      print " i"
    else
      if sinal$ = " -" then print sinal$; else print "  ";
      print using ImpIm$(k); PtIm#(k);
      print " i"
    end if
  end if
end sub
                                               ' impressao do polinomio minimo

sub ImprMin(re,RzRe#(1),min(1),ImpRz$(1),complex,CxDif$,PtRe#(1),PtIm#(1),_
            ImpRe$(1),ImpIm$(1),ImpSoma$(1),x$,ExpoComplex$)

on error goto FimMin
  tam = 6                           ' determina a primeira coluna de impressao
  if re > 0 then
    for i = 1 to re
      if RzRe(i) = 0 then tam = tam + 4 else tam = tam + 8 + len(ImpRz$(i))
    next i
  end if
  if complex > 0 then
    if CxDif$ = "nao" or complex = 1 then quantComp = 1 else quantComp = 2
    for i = 1 to quantComp
     if PtRe#(i) = 0 then
        tam = tam + 7 + len(ImpSoma$(i))
      else
        tam = tam + 13 + len(ImpSoma$(i)) + len(ImpRe$(i))
      end if
    next i
  end if
  posicao = int(30 - tam/2)
  if posicao <= 11 then posicao = 11
  col = posicao                               ' impressao dos expoentes
  if re > 0 then
    col = 11 + posicao + (len(ImpRz$(1)) + 4)*sgn(abs(RzRe#(1)))
  else
    col = 7 + posicao
  end if
  for i = 1 to re
    locate 16,col
    if min(i) > 1 then print using "#"; min(i);
    if i < re then
      if RzRe#(i + 1) <> 0 then
        col = col + 8 + len(ImpRz$(i + 1))
      else
        col = col + 4
      end if
    end if
  next i
  if complex <> 0 then
    if complex = 1 then
      col = col + 3 : locate 16,col
      print "2"
    else
      if CxDif$ = "sim" then
        for j = 1 to 2
          col = col + 3 : locate 16,col : print "2";
          if PtRe#(1) <> 0 then
            col = col + 12 + len(ImpRe$(1)) + len(ImpSoma$(1))
          else
            col = col + 5 + len(ImpSoma$(1))
          end if
        next j
      else
        col = col + 3 : locate 16,col : print "2";
        col = col + 5 + (len(ImRe$(1)) + 8)*sgn(abs(PtRe#(1)))+len(ImpSoma$(1))
        locate 16,col : print ExpoComplex$
      end if
    end if
  end if
  locate 17,posicao + 1 : print x$ + "(x) = ";     ' impressao das variaveis e
  for i = 1 to re                                  ' constantes
    if pos(0) > 67 then locate 19,posicao + 8
    print "(x";
    if RzRe#(i) <> 0 then
      if pos(0) > 65 then locate 19,posicao + 8
      if RzRe#(i) > 0 then print "  - "; else print "  + ";
      if pos(0) + len(ImpRz$(i)) > 69 then locate 19,posicao + 8
      print using ImpRz$(i); abs(RzRe#(i));
    end if
    if pos(0) > 67 then locate 19,posicao + 8
    print ") ";
  next i
  if complex = 2 and CxDif$ = "sim" then totComp = 2 else totComp = 1
  if complex = 0 then totComp = 0
  for i = 1 to totComp
    if pos(0) > 66 then locate 19,posicao + 8
    print "(x ";
    if PtRe#(i) <> 0 then
      if pos(0) > 66 then locate 19,posicao + 8
      if PtRe#(i) > 0 then print " - "; else print " + ";
      if pos(0) + len(ImpRe$(i)) > 68 then locate 19,posicao + 8
      print using "#" + ImpRe$(i); 2*abs(PtRe#(i));
      if pos(0) > 67 then locate 19,posicao + 8
      print " x ";
    end if
    if pos(0) + len(ImpSoma$(i)) > 64 then locate 19,posicao + 8
    print " + "; using ImpSoma$(i); PtRe#(i)^2 + PtIm#(i)^2;
    print ") ";
  next i
  exit sub
  FimMin:
  locate 17,11
  print "*** Erro de impressao - Use o item 11 (forma de Jordan) ***"
  on error goto 0
end sub

sub Separa(x$,y$)        ' separa os resultados impressos no papel com -------
  l = int(40 - len(x$)/2)
  w$ = string$(l,y$)
  lprint : lprint w$; x$; w$ : lprint
end sub
                                      ' impressao do polinomio minimo no papel

sub LImprMin(re,RzRe#(1),min(1),ImpRz$(1),complex,CxDif$,PtRe#(1),PtIm#(1),_
             ImpRe$(1),ImpIm$(1),ImpSoma$(1),x$,ExpoComplex$)

  if re > 0 then col = 12 + (len(ImpRz$(1)) + 4)*sgn(abs(RzRe#(1)))
  for i = 1 to re
    lprint spc(col);                                           ' impressao dos
    if min(i) > 1 then lprint using "#"; min(i);               ' expoentes
    if i < re then
      if RzRe#(i + 1) <> 0 then
        col = 7 + len(ImpRz$(i + 1))
      else
        col = 3
      end if
    end if
  next i
  if complex <> 0 then
    if re = 0 then corr = 8 else corr = 0
    if complex = 1 then
      col = 3 + corr : lprint spc(col); "2";
    else
      if CxDif$ = "sim" then
        col = 3 + corr
        for j = 1 to 2
          lprint spc(col); "2";
          if PtRe#(1) <> 0 then
            col = 14 + len(ImpRe$(1)) + len(ImpSoma$(1))
          else
            col = 7 + len(ImpSoma$(1))
          end if
        next j
      else
        col = 3 + corr : lprint spc(col); "2";
        col = 4 + (len(ImRe$(1)) + 8)*sgn(abs(PtRe#(1))) + len(ImpSoma$(1))
        lprint spc(col); ExpoComplex$;
      end if
    end if
  end if
  lprint
  lprint spc(2); x$ + "(x) = ";                    ' impressao das variaveis e
  for i = 1 to re                                  ' constantes
    lprint "(x";
    if RzRe#(i) <> 0 then
      if RzRe#(i) > 0 then lprint "  - "; else lprint "  + ";
      lprint using ImpRz$(i); abs(RzRe#(i));
    end if
    lprint ") ";
  next i
  if complex = 2 and CxDif$ = "sim" then totComp = 2 else totComp = 1
  if complex = 0 then totComp = 0
  for i = 1 to totComp
    lprint "(x ";
    if PtRe#(i) <> 0 then
      if PtRe#(i) > 0 then lprint " - "; else lprint " + ";
      lprint using "#" + ImpRe$(i); 2*abs(PtRe#(i));
      lprint " x ";
    end if
    lprint " + "; using ImpSoma$(i); PtRe#(i)^2 + PtIm#(i)^2;
    lprint ") ";
  next i : lprint
end sub

sub LImpPolCar(grau,coef#(1),impr$(1)) ' impressao do polinomio caracteristico
                                       ' no papel
  lprint spc(8); using "#"; grau;
  for i = 2 to grau - 1
    if coef#(i) <> 0 then
      if abs(coef#(i)) <> 1 then
        lprint spc(5 + len(impr$(i))); using "#"; grau - i + 1;
      else
        lprint spc(5); using "#"; i;
      end if
    end if
  next i
  lprint
  lprint "p(x) = x";
  for i = 2 to grau + 1
      if coef#(i) <> 0 then
      if coef#(i) > 0 then lprint "  + "; else lprint "  - ";
      if abs(coef#(i)) <> 1 or i=grau+1 then lprint using impr$(i);abs(coef#(i));
      if i <=  grau then lprint " x"; else lprint
    end if
  next i
end sub
                                ' impressao dos autovalores complexos no papel

sub LImprComplex(k,PtRe#(1),PtIm#(1),ImpRe$(1),ImpIm$(1),sinal$)
  lprint spc(38);
  if PtRe#(k) <> 0 then
    lprint using ImpRe$(k); PtRe#(k);
    if PtIm#(k) = 1 then
      lprint sinal$ + " i"
    else
      lprint sinal$;
      lprint using ImpIm$(k); PtIm#(k);
      lprint " i"
    end if
  else
    if PtIm#(k) = 1 then
      if sinal$ = " -" then lprint sinal$; else lprint "  ";
      lprint " i"
    else
      if sinal$ = " -" then lprint sinal$; else lprint "  ";
      lprint using ImpIm$(k); PtIm#(k);
      lprint " i"
    end if
  end if
end sub

sub Lmostra(a#(2),m,n,col1,col2)                   ' imprime a matriz no papel
  tipo = 1 : inteiro$ = "sim"
  for i = 1 to m
    for j = col1 to col2
      if a#(i,j) <> int(a#(i,j)) then inteiro$ = "nao"
      if abs(a#(i,j)) >= 100 then tipo = 2
      if abs(a#(i,j)) > 9999999.999 then call Final
    next j
  next i
  if inteiro$ = "sim" then
    if tipo = 1 then formimp$ = "####" else formimp$ = "#######"
    else
    if tipo = 1 then formimp$ = "####.####" else formimp$ = "#######.###"
  end if
  if len(formimp$) < 9 then
    espaco = 38 - n*int(len(formimp$)/2)
  else
    espaco = 36 - n*int(len(formimp$)/2)
  end if
  for i = 1 to m
    lprint spc(espaco);
    for j = col1 to col2
      lprint using formimp$; a#(i,j);
    next j
    lprint
  next i
end sub

$include "al2"

' continua em AL2.BAS ...

'     ========================= FIM DA PRIMEIRA PARTE =========================