
'     ============================== AL2.BAS =================================
'                 Este programa e' uma continuacao de AL1.BAS
'     ========================================================================

sub Inv(a#(2),m)                                    ' calculo da matriz inversa
  shared v
  dim c#(m, 2*m) : v = 1
  for i = 1 to m - 1
    l = i
    for w = m to i step -1
      if a#(w,i) <> 0 then l = w
    next w
    if a#(l,i) <> 0 then
      for col = 1 to 2*m
        swap a#(l,col), a#(i,col)
      next col
      for x = 1 to m
        for y = 1 to 2*m
          c#(x,y) = a#(x,y)
        next y
      next x
      for j = i + 1 to m
        for k = 1 to 2*m
          a#(j,k) = c#(i,i)*c#(j,k) - c#(j,i)*c#(i,k)
        next k
      next j
    end if
  next i
  for x = 1 to m
    c#(x,x) = a#(x,x)
    if c#(x,x) = 0 then
      v = 0 : erase c#
      exit sub
    end if
  next x
  for x = 1 to m
    for y = 1 to 2*m
      a#(x,y) = a#(x,y)/c#(x,x)
    next y
  next x
  for col = 2 to m
    for x = 1 to m
      for y = 1 to 2*m
        c#(x,y) = a#(x,y)
      next y
    next x
    for i = 1 to col - 1
      for j = 1 to 2*m
        a#(i,j) = c#(i,j) - c#(i,col)*c#(col,j)
      next j
    next i
  next col
  erase c#
end sub

sub Det(a#(2),n)                                      ' calculo do determinante
  shared determinante#
  dim aux#(n,n) : inversao = 0
  for i = 1 to n - 1
    l = i
    for w = n to i step -1
      if a#(w,i) <> 0 then l = w
    next w
    if a#(l,i) <> 0 then
      if l <> i then
        inversao = inversao + 1
        for s = 1 to n
          swap a#(l,s),a#(i,s)
        next s
      end if
      for x = 1 to n
        for y = 1 to n
          aux#(x,y) = a#(x,y)
        next y
      next x
      for j = i + 1 to n
        for k = 1 to n
          if aux#(i,i) = 0 then determinante# = 0 : erase aux# : exit sub
          a#(j,k) = aux#(j,k) - aux#(j,i)*aux#(i,k)/aux#(i,i)
        next k
      next j
    end if
  next i
  determinante# = 1
  for q = 1 to n
    determinante# = determinante#*a#(q,q)
  next q
  if inversao mod 2 <> 0 then determinante# = -determinante#
  erase aux#
end sub

sub Escalona(a#(2),m,n,opcao,erro3#,atr$)            ' escalonamento da matriz
  shared nulidade
  dim SomaLinha#(m + 1)
  if m <> n or ( m = n and m <= 5 and m >= 3 and opcao = 8 ) or ( m = n and _
    (m > 5 or m < 3 ) and opcao = 5 ) then
    cls
    locate 8,20 : print "SELECIONE O MODO DO ESCALONAMENTO ( 1 OU 2 ) :"
    locate 11,17 : print "1. Se a matriz contiver apenas elementos inteiros,"
    locate 12,20 : print "entao a  matriz  escalonada conter"; chr$(160); _
                         " apenas ele-"
    locate 13,20 : print "mentos inteiros, podendo serem grandes em m"; _
                          chr$(162); "du-"
    locate 14,20 : print "los"
    locate 16,17 : print "2. A matriz escalonada contem elementos os menores"
    locate 17,20 : print "possiveis em modulo, podendo nao serem inteiros"
    modo = val(input$(1)) : if modo <> 1 then modo = 2
  else
    modo = 2
  end if : if left$(atr$,1) <> "L" then exit sub
  dim aux#(m,n)
  linha = 1 : col = 1
  while linha <= m and col <= n
    gosub Aproxima : gosub Troca
    l = linha : tot = 0
    for i = m to linha step -1
      if a#(i,col) <> 0 then l = i : tot = 1
    next i
    if tot <> 0 then
      for j = col to n
        swap a#(l,j), a#(linha,j)
      next j
      for i = 1 to m
        for j = 1 to n
          aux#(i,j) = a#(i,j)
        next j
      next i
      for j = linha + 1 to m
        for k = 1 to n
          if modo = 1 then
            a#(j,k) = aux#(linha,col)*aux#(j,k) - aux#(j,col)*aux#(linha,k)
          else
            a#(j,k) = aux#(j,k) - aux#(j,col)*aux#(linha,k)/aux#(linha,col)
          end if
        next k
      next j
      linha = linha + 1
    end if
    col = col + 1
  wend
  erase aux#
  gosub Aproxima : gosub Troca

  nulidade = 0                                         ' calculo da nulidade
  for i = 1 to m
    elem = 0
    for j = 1 to n
      if abs(a#(i,j)) > erro3# then elem = 1
    next j
    if elem = 0 then nulidade = nulidade + 1
  next i
  for i = 1 to m
    SomaLinha#(i) = 0
    for j = 1 to n
      SomaLinha#(i) = SomaLinha#(i) + abs(a#(i,j))
    next j
  next i
  erase SomaLinha# : exit sub

  Troca:
  LinhaNula$ = "Em cima"           ' Coloca as linhas nulas para baixo.  O  al-
  while LinhaNula$ = "Em cima"     ' goritmo  aqui utilizado e'  semelhante  'a
    LinhaNula$ = "Em baixo"        ' "Classificacao por Borbulhamento"
    for i = 1 to m - 1
      if SomaLinha#(i) < erro3# and SomaLinha#(i + 1) > erro3# then
        LinhaNula$ = "Em cima"
        swap SomaLinha#(i),SomaLinha#(i + 1)
        for j = 1 to n
          swap a#(i,j),a#(i + 1,j)
        next j
      end if
    next i
  wend
  return

  Aproxima:
  for i = 1 to m
    for j = 1 to n
      a#(i,j) = fnAprox(a#(i,j),erro3#)
    next j
  next i
  return
end sub

sub ProdMat(mat#(3),a#(2),m,quant,z$)             ' produto de varias matrizes
  dim c#(m,m), u#(m,m)
  shared soma#
  if z$ = "" then exit sub
  for i = 1 to m
    for j = 1 to m
      if i = j then u#(i,j) = 1 else u#(i,j) = 0
    next j
  next i
  for w = 1 to quant
    for i = 1 to m
      for j = 1 to m
        c#(i,j) = 0
        for k = 1 to m
          c#(i,j) = c#(i,j) + u#(i,k)*mat#(w,k,j)
        next k
      next j
    next i
    for i = 1 to m
      for j = 1 to m
        u#(i,j) = c#(i,j)
      next j
    next i
  next w
  soma# = 0
  for i = 1 to m
    for j = 1 to m
      soma# = soma# + abs(u#(i,j))
    next j
  next i
  for i = 1 to m
    for j = 1 to m
      a#(i,j) = u#(i,j)
    next j
  next i
  erase u#,c#
end sub

sub Mensagem(x$,y$,z$,t$)                        ' mostra uma mensagem na tela
  cls
  locate 10,20 : print x$ : locate 12,20 : print y$
  locate 13,20 : print z$ : locate 14,20 : print t$
  delay 2 : cls : end
end sub

sub PolinomioCaracteristico(a#(2),m)      ' calculo do polinomio caracteristico
  shared coef#(),cf#()
  dim perm(m), q#(m), p#(m)
  coef#(1) = 1
  for i = 2 to 6
    coef#(i) = 0
  next i
  for i = 1 to m
    for j = 1 to m
      a#(i,j) = -a#(i,j)
    next j
  next i
  select case m
    case 3
      for i = 1 to 3
        for j = 1 to 3
          if i <> j then
            perm(1) = i : perm(2) = j : perm(3) = 6 - i - j
            gosub CalculoDoSinal
            produto# = sinal*q#(1)*q#(2)*q#(3)
            on fator gosub um, dois, tres, quatro
          end if
        next j
      next i
    case 4
      for i = 1 to 4
        for j = 1 to 4
          if i <> j then
            for k = 1 to 4
              if k <> j and k <> i then
                perm(1) = i : perm(2) = j : perm(3) = k : perm(4) = 10 - i-j-k
                gosub CalculoDoSinal
                produto# = sinal*q#(1)*q#(2)*q#(3)*q#(4)
                on fator gosub  um, dois, tres, quatro, cinco
              end if
            next k
          end if
        next j
      next i
    case 5
      for i = 1 to 5
        for j = 1 to 5
          if i <> j then
            for k = 1 to 5
              if k <> i and k <> j then
                for l = 1 to 5
                  if l <> i and l <> j and l <> k then
                    perm(1) = i : perm(2) = j : perm(3) = k
                    perm(4) = l : perm(5) = 15 - i - j - k - l
                    gosub CalculoDoSinal
                    produto# = sinal*q#(1)*q#(2)*q#(3)*q#(4)*q#(5)
                    on fator gosub um, dois, tres, quatro, cinco, seis
                  end if
                next l
              end if
            next k
          end if
        next j
      next i
    end select
  erase perm, p#, q#
  for i = 1 to m + 1
    coef#(i) = coef#(i - m + 5)
    cf#(i) = coef#(i)
  next i
  exit sub

  CalculoDoSinal:
  sinal = 0
  for x = 1 to m - 1
    for y = x + 1 to m
      if perm(x) > perm(y) then sinal = sinal + 1
    next y
  next x
  sinal = (-1)^sinal
  fator = 1
  for x = 1 to m
    if perm(x) <> x then
      q#(x) = a#(x,perm(x))
    else
      p#(fator) = a#(x,x)
      q#(x) = 1
      fator = fator + 1
    end if
  next x
  return

  um:
  coef#(6) = coef#(6) + produto#
  return

  dois:
  coef#(5) = coef#(5) + produto#
  coef#(6) = coef#(6) + produto#*p#(1)
  return

  tres:
  coef#(4) = coef#(4) + produto#
  coef#(5) = coef#(5) + produto#*(p#(1) + p#(2))
  coef#(6) = coef#(6) + produto#*p#(1)*p#(2)
  return

  quatro:
  coef#(3) = coef#(3) + produto#
  coef#(4) = coef#(4) + produto#*(p#(1) + p#(2) + p#(3))
  coef#(5) = coef#(5) + produto#*(p#(1)*p#(2) + p#(1)*p#(3) + p#(2)*p#(3))
  coef#(6) = coef#(6) + produto#*p#(1)*p#(2)*p#(3)
  return

  cinco:
  coef#(2) = coef#(2) + produto#
  coef#(3) = coef#(3) + produto#*(p#(1) + p#(2) + p#(3) + p#(4))
  coef#(4) = coef#(4) +  produto#*(p#(1)*p#(2) + p#(1)*p#(3) +  p#(1)*p#(4) + _
             p#(2)*p#(3) + p#(2)*p#(4) + p#(3)*p#(4))
  coef#(5) = coef#(5) +  produto#*(p#(1)*p#(2)*p#(3)  +  p#(1)*p#(2)*p#(4)  + _
             p#(2)*p#(3)*p#(4) + p#(1)*p#(3)*p#(4))
  coef#(6) = coef#(6) + produto#*p#(1)*p#(2)*p#(3)*p#(4)
  return

  seis:
  coef#(2) = coef#(2) + produto#*(p#(1) + p#(2) + p#(3) + p#(4) + p#(5))
  coef#(3) = coef#(3) + produto#*(p#(1)*p#(2) +  p#(1)*p#(3)  + p#(1)*p#(4) + _
             p#(1)*p#(5) + p#(2)*p#(3) + p#(2)*p#(4)  +  p#(2)*p#(5) +  p#(3)*_
             p#(4) + p#(3)*p#(5) + p#(4)*p#(5))
  coef#(4) = coef#(4) + produto#*(p#(1)*p#(2)*p#(3)  +  p#(1)*p#(2)*p#(4)  +  _
             p#(1)*p#(2)*p#(5) +  p#(1)*p#(3)*p#(4)  +  p#(1)*p#(3)*p#(5)  +  _
             p#(1)*p#(4)*p#(5)  +  p#(2)*p#(3)*p#(4)  +  p#(2)*p#(3)*p#(5) +  _
             p#(2)*p#(4)*p#(5) + p#(3)*p#(4)*p#(5))
  coef#(5) = coef#(5)  + produto#*(p#(1)*p#(2)*p#(3)*p#(4) + p#(1)*p#(2)*p#(3)_
             *p#(5)  +  p#(1)*p#(3)*p#(4)*p#(5)  +  p#(2)*p#(3)*p#(4)*p#(5) + _
             p#(1)*p#(2)*p#(4)*p#(5))
  coef#(6) = coef#(6) + produto#*p#(1)*p#(2)*p#(3)*p#(4)*p#(5)
  return
end sub

' As  quatro funcoes  definidas a  seguir sao  usadas na  resolucao de equacoes
' algebricas (calculo dos autovalores)

def fnf#(x#) = x#^5  +  coef#(2)*x#^4  +  coef#(3)*x#^3  +  coef#(4)*x#^2  +  _
               coef#(5)*x# +  coef#(6)

def fnAprox#(x#,erro#)                                  ' transforma x em [x],
  if abs(x# - int(x#)) < erro# then                     ' [x] + 1 ou x
    fnAprox# = int(x#)
  else
    if abs(x# - int(x#) - 1 ) < erro# then
      fnAprox# = int(x#) + 1
    else
      fnAprox# = x#
    end if
  end if
end def

def fnDelta1#(x#,y#,z#,erro#) = fnAprox#(x#^2 - 4*y# + 4*z#,erro#)

def fnDelta2#(x#,y#,erro#) = fnAprox#(x#^2 - 4*y#,erro#)

sub ResolveEquacao(cf#(1),grau,erro1#,erro2#)         ' resolucao de equacoes
  shared RzRe#(), PtRe#(), PtIm#(), expo()            ' algebricas
  shared re, complex, CxDif$
  for i = 1 to 5
    expo(i) = 0
  next i
  re = 0 : complex = 0
  on grau - 2 goto EqTercGrau, EqQuartoGrau, EqQuintoGrau

  EqQuintoGrau:
  if cf#(6) = 0 then raiz# = 0 : goto fim
  x1# = 0 : x# = 1
  intervalo:                    ' procura um intervalo no qual f muda de sinal
  if abs(fnf#(x#)) < erro2# then raiz# = x# : goto fim
  if cf#(6)*fnf#(x#) < 0 then
    x2# = x# : goto iteracao
  else
    x# = -x#
  end if
  if abs(fnf#(x#)) < erro2# then raiz# = x# : goto fim
  if cf#(6)*fnf#(x#) < 0 then
    x1# = x# : x2# = 0 : goto iteracao
  else
    x# = -x# : x# = x# + 1
  end if
  goto intervalo
  iteracao:                   ' procura uma raiz de f(x) no intervalo [x1, x2]
  while abs(x1# - x2#) > erro2#
    v1# = fnf#(x1#) : if v1# = 0 then raiz# = x1# : goto fim
    v2# = fnf#(x2#) : if v2# = 0 then raiz# = x2# : goto fim
    vm# = fnf#((x1# + x2#)/2) : if vm# = 0 then raiz# = (x1#+x2#)/2 : goto fim
    if v1#*vm# < 0 then x2# = (x1# + x2#)/2 else x1# = (x1# + x2#)/2
  wend
  raiz# = (x1# + x2#)/2
  fim:
  re = re + 1 : expo(re) = expo(re) + 1 : RzRe#(re) = raiz#
  cf#(5) = raiz#^4 + cf#(2)*raiz#^3 + cf#(3)*raiz#^2 + cf#(4)*raiz# + cf#(5)
  cf#(4) = raiz#^3 + cf#(2)*raiz#^2 + cf#(3)*raiz#   + cf#(4)
  cf#(3) = raiz#^2 + cf#(2)*raiz#   + cf#(3)
  cf#(2) = raiz#   + cf#(2)
  grau = 4

  EqQuartoGrau:
  b# = -cf#(3) : c# = cf#(2)*cf#(4) - 4*cf#(5)
  d# = 4*cf#(3)*cf#(5) - cf#(4)^2 - cf#(2)^2*cf#(5)
  goto EqTercGrau
  PontoDeRetorno1:
  if fnDelta1#(cf#(2),cf#(3),r#,erro1#) >= 0 and fnDelta2#(r#,cf#(5),_
    erro1#) >= 0 then goto PtInicial
  hh = 1 : goto Lugar1
  PontoDeRetorno2:
  r# = r1#
  if fnDelta1#(cf#(2),cf#(3),r#,erro1#) >= 0 and fnDelta2#(r#,cf#(5),_
    erro1#) >= 0 then goto PtInicial
  r# = r2#
  if fnDelta1#(cf#(2),cf#(3),r#,erro1#) < 0 or fnDelta2#(r#,cf#(5),_
    erro1#) < 0 then end
  PtInicial:
  hh = 0
  b1# = .5*(cf#(2) + sqr(fnDelta1(cf#(2),cf#(3),r#,erro1#)))
  b2# = .5*(cf#(2) - sqr(fnDelta1(cf#(2),cf#(3),r#,erro1#)))
  c1# = .5*(r# + sqr(fnDelta2(r#,cf#(5),erro1#)))
  c2# = .5*(r# - sqr(fnDelta2(r#,cf#(5),erro1#)))
  if abs(b1# + b2# - cf#(2)) < erro1# and abs(c1#*c2# - cf#(5))  < erro1# _
    and abs(b1#*b2# + c1# + c2# -  cf#(3)) < erro1# and abs(b1#*c2# + c1#*_
    b2# - cf#(4)) < erro1# then
    caso = 1
    if b1#^2 - 4*c1# < 0 then swap b1#,b2# : swap c1#,c2#
    b# = b1# : c# = c1# : goto EqSegundoGrau
    PontoDeRetorno3:
    grau = 2
    b# = b2# : c# = c2# : goto EqSegundoGrau
  else
    caso = 2
    if b1#^2 - 4*c2# < 0 then swap b1#,b2# : swap c1#,c2#
    b# = b1# : c# = c2# : goto EqSegundoGrau
    PontoDeRetorno4:
    grau = 2
    b# = b2# : c# = c1# : goto EqSegundoGrau
  end if

  EqTercGrau:
  if grau = 3 then b# = cf#(2) : c# = cf#(3) : d# = cf#(4)
  alfa# = (3*c# - b#^2)/3
  beta# = (27*d# + 2*b#^3 - 9*b#*c#)/27
  mm# = -beta#/2 : nn# = (alfa#/3)^3 + (beta#/2)^2
  if nn# >= 0 then
    u# = mm# + sqr(nn#)
    v# = mm# - sqr(nn#)
    r# = -b#/3 + sgn(u#)*abs(u#)^(1/3) + sgn(v#)*abs(v#)^(1/3)
  else
    pi# = 3.14159265358979323
    z# = mm#/sqr(mm#^2 - nn#)
    if z# > 0 then
      arg# = atn(sqr(1 - z#^2)/z#)
    else
      if z# = 0 then
        arg# = pi#/2
      else
        arg# = pi# + atn(sqr(1 - z#^2)/z#)
      end if
    end if
    r# = -b#/3 + 2*(mm#^2 - nn#)^(1/6)*cos(arg#/3)
    r# = fnAprox#(r#,erro1#)
  end if
  if grau = 4 then goto PontoDeRetorno1
  re = re + 1
  RzRe#(re) = r#
  expo(re) = 1
  Lugar1:
  c# = r#^2 + b#*r# + c#
  b# = r# + b#

  EqSegundoGrau:
  dt# = fnAprox#(b#^2 - 4*c#,erro1#)
  if dt# >= 0 then
    r1# = fnAprox#((-b# + sqr(dt#))/2,erro1#)
    r2# = fnAprox#((-b# - sqr(dt#))/2,erro1#)
    if hh = 1 then goto PontoDeRetorno2
    for i = 1 to re
      if RzRe#(i) = r1# then expo(i) = expo(i) + 1 : goto Lugar2
    next i
    re = re + 1
    RzRe#(re) = r1#
    expo(re) = 1
    Lugar2:
    for i = 1 to re
      if RzRe#(i) = r2# then expo(i) = expo(i) + 1 : goto Lugar3
    next i
    re = re + 1
    RzRe#(re) = r2#
    expo(re) = 1
    Lugar3:
    if grau = 4 then
      if caso = 1 goto PontoDeRetorno3 else goto PontoDeRetorno4
    end if
  else
    complex = complex + 1
    PtRe#(complex) = fnAprox#(-b#/2,erro1#)
    PtIm#(complex) = fnAprox#(sqr(-dt#)/2,erro1#)
    if hh = 1 then end
    if complex = 2 then
      if PtRe#(1) = PtRe#(2) and PtIm#(1) = PtIm#(2) then CxDif$ = "nao" else _
        CxDif$ = "sim"
    end if
    if grau = 4 then
      if caso = 1 then goto PontoDeRetorno3 else goto PontoDeRetorno4
    end if
  end if
end sub

$segment

sub Classifica(expo(1),min(1),RzRe#(1),re)  ' Ordena os expoentes da fatoracao
  inversao$ = "sim"                         ' do polinomio minimo em ordem de-
  while inversao$ = "sim"                   ' crescente .  Este  algoritmo  e'
    inversao$ = "nao"                       ' conhecido   como  "Classificacao
    for i = 1 to re - 1                     ' por Borbulhamento"
      if expo(i) < expo(i + 1) then
        inversao$ = "sim"
        swap expo(i), expo(i + 1)
        swap min(i), min(i + 1)
        swap RzRe#(i), RzRe#(i + 1)
      end if
    next i
  wend
end sub

sub Autovetores(a#(2),n)                                                  ' C
  shared v#(), QuantAutov
  for i = 1 to 5                                                          ' A
    for j = 1 to 5
      v#(i,j) = 0                                                         ' L
    next j
  next i                                                                  ' C
  select case n
    case 3                                                                ' U
      if a#(1,1) <> 0 then
        if a#(2,2) <> 0 then                                              ' L
          QuantAutov = 1
          v#(1,3) = 1 : v#(1,2) = -a#(2,3)/a#(2,2)                        ' O
          v#(1,1) = -(a#(1,3) + a#(1,2)*v#(1,2))/a#(1,1)
        else
        v#(1,1) = -a#(1,2)/a#(1,1) : v#(1,2) = 1
          if a#(2,3) <> 0 then
            QuantAutov = 1
          else                                                            ' D
            QuantAutov = 2
            v#(2,1) = -a#(1,3)/a#(1,1) : v#(2,3) = 1                      ' O
          end if
        end if                                                            ' S
      else
        v#(1,1) = 1
        if a#(1,2) <> 0 then
          if a#(2,3) <> 0 then
            QuantAutov = 1                                                ' A
          else
            QuantAutov = 2                                                ' U
            v#(2,2) = -a#(1,3)/a#(1,2) : v#(2,3) = 1
          end if                                                          ' T
        else
          v#(2,2) = 1                                                     ' O
          if a#(1,3) <> 0 then
            QuantAutov = 2                                                ' V
          else
            QuantAutov = 3                                                ' E
            v#(3,3) = 1
          end if                                                          ' T
        end if
      end if                                                              ' O
    case 4
      if a#(1,1) <> 0 then                                                ' R
        if a#(2,2) <> 0 then
          if a#(3,3) <> 0 then                                            ' E
            QuantAutov = 1
            v#(1,4) = 1 : v#(1,3) = -a#(3,4)/a#(3,3)                      ' S
            v#(1,2) = -(a#(2,4) + a#(2,3)*v#(1,3))/a#(2,2)
            v#(1,1) = -(a#(1,4) + a#(1,3)*v#(1,3) + a#(1,2)*v#(1,2))/a#(1,1)
          else
            v#(1,3) = 1 : v#(1,2) = -a#(2,3)/a#(2,2)
            v#(1,1) = -(a#(1,3) + a#(1,2)*v#(1,2))/a#(1,1)
            if a#(3,4) <> 0 then
              QuantAutov = 1
            else
              QuantAutov = 2
              v#(2,4) = 1 : v#(2,2) = -a#(2,4)/a#(2,2)
              v#(2,1) = -(v#(2,2)*a#(1,2) + a#(1,4))/a#(1,1)
            end if
          end if
        else
          if a#(2,3) <> 0 then
            if a#(3,4) <> 0 then
              QuantAutov = 1
              v#(1,2) = 1 : v#(1,1) = -a#(1,2)/a#(1,1)
            else
              QuantAutov = 2
              v#(1,2) = 1 : v#(1,1) = -a#(1,2)/a#(1,1)
              v#(2,4) = 1 : v#(2,3) = -a#(2,4)/a#(2,3)
              v#(2,1) = -(a#(1,4) + a#(1,3)*v#(2,3))/a#(1,1)
            end if
          else
            if a#(2,4) <> 0 then
              QuantAutov = 2
              v#(1,3) = 1 : v#(1,1) = -a#(1,3)/a#(1,1) : v#(2,2) = 1
              v#(2,1) = -a#(1,2)/a#(1,1)
            else
              QuantAutov = 3
              v#(1,1) = -a#(1,2)/a#(1,1) : v#(2,1) = -a#(1,3)/a#(1,1)
              v#(3,1) = -a#(1,4)/a#(1,1) : v#(1,2) = 1
              v#(2,3) = 1 : v#(3,4) = 1
            end if
          end if
        end if
      else
        v#(1,1) = 1
        if a#(1,2) <> 0 then
          if a#(2,3) <> 0 then
            if a#(3,4) <> 0 then
              QuantAutov = 1
            else
              QuantAutov = 2
              v#(2,4) = 1 : v#(2,3) = -a#(2,4)/a#(2,3)
              v#(2,2) = -(a#(1,4) + a#(1,3)*v#(2,3))/a#(1,2)
            end if
          else
            if a#(2,4) <> 0 then
              QuantAutov = 2
              v#(2,2) = -a#(1,3)/a#(1,2) : v#(2,3) = 1
            else
              QuantAutov = 3
              v#(2,4) = 1 : v#(3,3) = 1 : v#(2,2) = -a#(1,4)/a#(1,2)
              v#(3,2) = -a#(1,3)/a#(1,2)
            end if
          end if
        else
          if a#(1,3) <> 0 then
            if a#(2,4) <> 0 then
              QuantAutov = 2
              v#(2,2) = 1
            else
              QuantAutov = 3
              v#(2,2) = 1 : v#(3,3) = -a#(1,4)/a#(1,3) : v#(3,4) = 1
            end if
          else
            if a#(1,4) <> 0 then
              QuantAutov = 3
              v#(2,2) = 1 : v#(3,3) = 1
            else
              QuantAutov = 4
              v#(2,2) = 1 : v#(3,3) = 1 : v#(4,4) = 1
            end if
          end if
        end if
      end if
    case 5
      if a#(1,1) <> 0 then
        if a#(2,2) <> 0 then
          if a#(3,3) <> 0 then
            if a#(4,4) <> 0 then
              QuantAutov = 1
              v#(1,5) = 1 : v#(1,4) = -a#(4,5)/a#(4,4)
              v#(1,3) = -(a#(3,5) + v#(1,4)*a#(3,4))/a#(3,3)
              v#(1,2) = -(a#(2,5) + v#(1,4)*a#(2,4) + v#(1,3)*a#(2,3))/a#(2,2)
              v#(1,1) = -(a#(1,5) + v#(1,4)*a#(1,4) + v#(1,3)*a#(1,3) + _
                        v#(1,2)*a#(1,2))/a#(1,1)
            else
              if a#(4,5) <> 0 then
                QuantAutov = 1
                v#(1,4) = 1 : v#(1,3) = -a#(3,4)/a#(3,3)
                v#(1,2) = -(v#(1,3)*a#(2,3) + a#(2,4))/a#(2,2)
                v#(1,1) = -(v#(1,2)*a#(1,2)+v#(1,3)*a#(1,3)+a#(1,4))/a#(1,1)
              else
                QuantAutov = 2
                v#(1,5) = 1 : v#(1,3) = -a#(3,5)/a#(3,3)
                v#(1,2) = -(a#(2,3)*v#(1,3) + a#(2,5))/a#(2,2)
                v#(1,1) = -(a#(1,2)*v#(1,2) + a#(1,3)*v#(1,3)+a#(1,5))/a#(1,1)
                v#(2,4) = 1 : v#(2,3) = -a#(3,4)/a#(3,3)
                v#(2,2) = -(a#(2,3)*v#(2,3) + a#(2,4))/a#(2,2)
                v#(2,1) = -(a#(1,2)*v#(2,2) + a#(1,3)*v#(2,3)+a#(1,4))/a#(1,1)
              end if
            end if
          else
            if a#(3,4) <> 0 then
              v#(1,3) = 1 : v#(1,2) = -a#(2,3)/a#(2,2)
              v#(1,1) = -(a#(1,3) + a#(1,2)*v#(1,2))/a#(1,1)
              if a#(4,5) <> 0 then
                QuantAutov = 1
              else
                QuantAutov = 2
                v#(2,5) = 1 : v#(2,4) = -a#(3,5)/a#(3,4)
                v#(2,2) = -(a#(2,5) + a#(2,4)*v#(2,4))/a#(2,2)
                v#(2,1) = -(a#(1,2)*v#(2,2)+a#(1,4)*v#(1,4)+a#(1,5))/a#(1,1)
              end if
            else
              v#(1,3) = 1 : v#(1,2) = -a#(2,3)/a#(2,2)
              v#(1,1) = -(a#(1,2)*v#(1,2) + a#(1,3))/a#(1,1)
              v#(2,4) = 1 : v#(2,2) = -a#(2,4)/a#(2,2)
              v#(2,1) = -(a#(1,2)*v#(2,2) + a#(1,4))/a#(1,1)
              if a#(3,5) <> 0 then
                QuantAutov = 2
              else
                QuantAutov = 3
                v#(3,5) = 1 : v#(3,2) = -a#(2,5)/a#(2,2)
                v#(3,1) = -(a#(1,2)*v#(3,2) + a#(1,5))/a#(1,1)
              end if
            end if
          end if
        else
          if a#(2,3) <> 0 then
            if a#(3,4) <> 0 then
              if a#(4,5) <> 0 then
                QuantAutov = 1
                v#(1,1) = -a#(1,2)/a#(1,1) : v#(1,2) = 1
              else
                QuantAutov = 2
                v#(1,5) = 1 : v#(1,4) = -a#(3,5)/a#(3,4)
                v#(1,3) = -(a#(2,5) + a#(2,4)*v#(1,4))/a#(2,3)
                v#(1,1) = -(a#(1,3)*v#(1,3)+a#(1,4)*v#(1,4)+a#(1,5))/a#(1,1)
                v#(2,1) = -a#(1,2)/a#(1,1) : v#(2,2) = 1
              end if
            else
              v#(1,1) = -a#(1,2)/a#(1,1) : v#(1,2) = 1
              v#(2,4) = 1 : v#(2,3) = -a#(2,4)/a#(2,3)
              v#(2,1) = -(a#(1,3)*v#(2,3) + a#(1,4))/a#(1,1)
              if a#(3,5) <> 0 then
                QuantAutov = 2
              else
                QuantAutov = 3
                v#(3,5) = 1 : v#(3,3) = -a#(2,5)/a#(2,3)
                v#(3,1) = -(a#(1,5) + a#(1,3)*v#(3,3))/a#(1,1)
              end if
            end if
          else
          v#(1,1) = -a#(1,2)/a#(1,1) : v#(1,2) = 1
          v#(2,1) = -a#(1,3)/a#(1,1) : v#(2,3) = 1
            if a#(2,4) <> 0 then
              if a#(3,5) <> 0 then
                QuantAutov = 2
              else
                QuantAutov = 3
                v#(3,5) = 1 : v#(3,4) = -a#(2,5)/a#(2,4)
                v#(3,1) = -(a#(1,5) + a#(1,4)*v#(3,4))/a#(1,1)
              end if
            else
              if a#(2,5) <> 0 then
                QuantAutov = 3
                v#(3,1) = -a#(1,4)/a#(1,1) : v#(3,4) = 1
              else
                QuantAutov = 4
                v#(3,1) = -a#(1,4)/a#(1,1) : v#(3,4) = 1
                v#(4,1) = -a#(1,5)/a#(1,1) : v#(4,5) = 1
              end if
            end if
          end if
        end if
      else
        v#(1,1) = 1
        if a#(1,2) <> 0 then
          if a#(2,3) <> 0 then
            if a#(3,4) <> 0 then
              if a#(4,5) <> 0 then
                QuantAutov = 1
              else
                QuantAutov = 2
                v#(2,5) = 1 : v#(2,4) = -a#(3,5)/a#(3,4)
                v#(2,3) = -(a#(2,4)*v#(2,4) + a#(2,5))/a#(2,3)
                v#(2,2) = -(a#(1,3)*v#(2,3) + a#(1,4)*v#(2,4)+a#(1,5))/a#(1,2)
              end if
            else
            v#(2,3) = -a#(2,4)/a#(2,3) : v#(2,4) = 1
            v#(2,2) = -(a#(1,3)*v#(2,3) + a#(1,4))/a#(1,2)
              if a#(3,5) <> 0 then
                QuantAutov = 2
              else
                QuantAutov = 3
                v#(3,3) = -a#(2,5)/a#(2,3) : v#(3,5) = 1
                v#(3,2) = -(a#(1,3)*v#(3,3) + a#(1,5))/a#(1,2)
              end if
            end if
          else
            if a#(2,4) <> 0 then
              if a#(3,5) <> 0 then
                QuantAutov = 2
                v#(2,2) = -a#(1,3)/a#(1,2) : v#(2,3) = 1
              else
                QuantAutov = 3
                v#(2,3) = 1 : v#(2,2) = -a#(1,3)/a#(1,2)
                v#(3,4) = -a#(2,5)/a#(2,4) : v#(3,5) = 1
                v#(3,2) = -(a#(1,5) + a#(1,4)*v#(3,4))/a#(1,2)
              end if
            else
              v#(2,3) = 1 : v#(2,2) = -a#(1,3)/a#(1,2)
              v#(3,4) = 1 : v#(3,2) = -a#(1,4)/a#(1,2)
              if a#(2,5) <> 0 then
                QuantAutov = 3
              else
                QuantAutov = 4
                v#(4,5) = 1 : v#(4,2) = -a#(1,5)/a#(1,2)
              end if
            end if
          end if
        else
          v#(2,2) = 1
          if a#(1,3) <> 0 then
            if a#(2,4) <> 0 then
              if a#(3,5) <> 0 then
                QuantAutov = 2
              else
                QuantAutov = 3
                 v#(3,5) = 1 : v#(3,4) = -a#(2,5)/a#(2,4)
                 v#(3,3) = -(a#(1,5) + a#(1,4)*v#(3,4))/a#(1,3)
              end if
            else
              v#(3,3) = -a#(1,4)/a#(1,3) : v#(3,4) = 1
              if a#(2,5) <> 0 then
                QuantAutov = 3
              else
                QuantAutov = 4
                v#(4,3) = -a#(1,5)/a#(1,3) : v#(4,5) = 1
              end if
            end if
          else
            v#(3,3) = 1
            if a#(1,4) <> 0 then
              if a#(2,5) <> 0 then
                QuantAutov = 3
              else
                QuantAutov = 4
                v#(4,5) = 1 : v#(4,4) = -a#(1,5)/a#(1,4)
              end if
            else
              v#(4,4) = 1
              if a#(1,5) <> 0 then
                QuantAutov = 4
              else
                QuantAutov = 5
                v#(5,5) = 1
              end if
            end if
          end if
        end if
      end if
  end select
end sub

sub ImpAutovetores(x#,quant,v#(2),n,autov$(2),linha,ImpRz$,w$)
  shared l
  l = linha : coluna1 = 12 : coluna2 = 29                      ' impressao dos
  if w$ = "tela" then                                          ' autovetores
    locate l, coluna1
    print "[ " chr$(224) " = ";
    print using ImpRz$; x#;
    print " ]"
    for w = 1 to quant
      locate l, coluna2
      print "(" using autov$(w,1); v#(w,1);
      for z = 2 to n
        print "," using autov$(w,z); v#(w,z);
      next z
      print ")"
      l = l + 1
    next w
  else
    lprint spc(3); "[ x = ";
    lprint using ImpRz$; x#;
    lprint " ]";
    for w = 1 to quant
      if w = 1 then lprint spc(12); else lprint spc(25);
      lprint "( "; using autov$(w,1); v#(w,1);
      for z = 2 to n
        lprint " , "; using autov$(w,z); v#(w,z);
      next z
      lprint " )"
      l = l + 1
    next w
  end if
end sub

sub ImpJordan(a$(2),n,re,RzRe#(1),TotRe,w$)     ' impressao da forma de Jordan
  inteiro$ = "sim" : tipo = 1
  for i = 1 to re
    if RzRe#(i) <> int(RzRe#(i)) then inteiro$ = "nao"
    if abs(RzRe#(i)) > 99 then tipo = 2
    if abs(RzRe#(i)) > 9999999.999 then call Final
  next i
  if tipo = 1 then
    if inteiro$ = "sim" then
      jordan$ = "####"
      um$   =   "   1" : cx1$ = "a+bi" : cx2$ = "a-bi"
      zero$  =  "    " : cx3$ = "c+di" : cx4$ = "c-di"
    else
      jordan$ = "####.###"
      um$ =     "       1"  : cx1$ = "  a + bi" : cx2$ = "  a - bi"
      zero$ =   "        "  : cx3$ = "  c + di" : cx4$ = "  c - di"
    end if
  else
    if inteiro$ = "sim" then
      jordan$ = "######"
      um$   =   "     1" : cx1$ = "a + bi" : cx2$ = "a - bi"
      zero$ =   "      " : cx3$ = "c + di" : cx4$ = "c - di"
    else
      jordan$ = "######.###"
      um$   =   "         1" : cx1$ = "    a + bi" : cx2$ = "    a - bi"
      zero$ =   "          " : cx3$ = "    c + di" : cx4$ = "    c - di"
    end if
  end if
  coluna = 38 - n*int(len(jordan$)/2)
  if w$ = "tela" then
    linha = 14
    locate linha, coluna
    print chr$(218); spc(n*len(jordan$) + 2); chr$(191)
    for i = 1 to n
      locate linha + i, coluna
      print chr$(179);
      for j = 1 to n
        if i = j and i <= TotRe then
          print using jordan$; val(a$(i,j));
        elseif a$(i,j) = "" then
          print zero$;
        elseif a$(i,j) = "1" then
          print um$;
        elseif a$(i,j) = "x1" then
          print cx1$;
        elseif a$(i,j) = "x2" then
          print cx2$;
        elseif a$(i,j) = "x3" then
          print cx3$;
        elseif a$(i,j) = "x4" then
          print cx4$;
        end if
      next j
      print "  " + chr$(179)
    next i
    locate linha + i, coluna
    print chr$(192); spc(n*len(jordan$) + 2); chr$(217)
  else
    for i = 1 to n
      lprint spc(coluna);
      for j = 1 to n
        if i = j and i <= TotRe then
          lprint using jordan$; val(a$(i,j));
        elseif a$(i,j) = "" then
          lprint zero$;
        elseif a$(i,j) = "1" then
          lprint um$;
        elseif a$(i,j) = "x1" then
          lprint cx1$;
        elseif a$(i,j) = "x2" then
          lprint cx2$;
        elseif a$(i,j) = "x3" then
          lprint cx3$;
        elseif a$(i,j) = "x4" then
          lprint cx4$;
        end if
      next j
      lprint
    next i
  end if
end sub

sub MolduraInf(pag)                                 ' moldura de "Informacoes"
  cls
  print chr$(218); string$(77,196); chr$(191)
  locate 1,34 : print " INFORMA"; chr$(128); "OES "
  for i = 2 to 22
    locate i,1 : print chr$(179)
    locate i,79 : print chr$(179)
  next i
  locate 22,1
  print chr$(192); string$(77,196); chr$(217)
  locate 23,5  : print "C : continua"
  locate 23,23 : print "A : p"; chr$(160); "gina anterior"
  locate 23,48 : print "V : volta ao menu"
  locate 23,70 : print "pag." ; using "##"; pag
end sub

sub Informacoes             ' informacoes gerais a respeito do uso do programa
  pagina1:
  call MolduraInf(1)
  locate 3,5 : print _
  " "; chr$(16); " Entrada da matriz:"
  locate 5,5 : print _
  "      Existem duas maneiras de entrar com uma matriz:  pelo teclado  ou"
  locate 6,5 : print _
  " atrav"; chr$(130); "s da leitura do disquete."
  locate 7,5 : print _
  "      Pelo teclado, a matriz deve entrar no formato usual. Inicialmente"
  locate 8,5 : print _
  " ser"; chr$(160); "  solicitada a ordem da matriz. Depois voce dever";
  print chr$(160); "  entrar  com os" : locate 9,5 : print _
  " elementos um por um, teclando <ENTER>  entre um elemento e  outro.  Os"
  locate 10,5 : print _
  " elementos nulos nao precisam  ser  digitados. Por exemplo, para entrar"
  locate 11,5 : print _
  " com a matriz identidade 3 x 3 basta digitar o seguinte:"
  locate 13,5 : print _
  "        <3><ENTER> <3><ENTER>         <1><ENTER> <ENTER> <ENTER>"
  locate 14,5 : print _
  "        <ENTER> <1><ENTER> <ENTER>    <ENTER> <ENTER> <1><ENTER>"
  locate 16,5 : print _
  "      Podem entrar n"; chr$(163); "meros na forma p/q como 1/2, -5/3 ou";
  print " 4.76/37.684 .  " : locate 17,5 : print _
  "      A leitura de uma matriz que foi gravada previamente  no  disquete"
  locate 18,5 : print _
  " pode ser feita desde que seja especificado  exatamente o local onde  a"
  locate 19,5 : print _
  " matriz se encontra gravada (drive, subdiret";chr$(162);"rio, nome, etc.)."
  locate 20,5 : print _
  "      O nome pode ser formado por qualquer  conjunto de no  m"; chr$(160);
  print "ximo oito" : x$ = ucase$(input$(1))
  if x$ = "V" then exit sub else if x$ = "A" then goto pagina7
  pagina2:
  call MolduraInf(2)
  locate 3,5 : print _
  " letras ou algarismos. O drive ou o subdiret"; chr$(162);
  print "rio podem preceder o nome." : locate 4,5 : print _
  " O nome do drive deve ser seguido por : , como nos exemplos abaixo."
  locate 6,5 : print _
  "       MATRIZ1   ,   B:X2   ,   A:\MAT3   ,   C:\EXEMPLOS\TESTE5"
  locate 8,5 : print _
  "      O programa acrescentar"; chr$(160); " a todas as matrizes uma  ";
  print "extensao  .MAT ." : locate 9,5 : print _
  " O usu"; chr$(160); "rio nao dever"; chr$(160); " usar essa extensao na";
  print " especificacao do nome." : locate 10,5 : print _
  "      Na leitura da matriz do disco, se for respondido um  ? como sendo"
  locate 11,5 : print _
  " o nome da matriz e o disco do drive A contiver os arquivos  FIND.EXE e"
  locate 12,5 : print _
  " COMMAND.COM do Sistema Operacional, entao ser" chr$(160);
  print " fornecida a rela"; chr$(135); "ao  de" : locate 13,5 : print _
  " todos os nomes das matrizes que estiverem no local especificado."
  locate 15,5 : print _
  " "; chr$(16); " Apresenta"; chr$(135); "ao dos resultados:"
  locate 17,5 : print _
  "      Sempre que  uma tela permanecer  estacion"; chr$(160); "ria,";
  print "  o usu"; chr$(160); "rio  dever"; chr$(160)
  locate 18,5 : print _
  " pressionar uma ou duas teclas para que o programa continue. Se  a tela"
  locate 19,5 : print _
  " for um menu, entao deverao ser pressionadas teclas num"; chr$(130);
  print "ricas. Se for a" : locate 20,5 : print " apresenta"; chr$(135);
  print "ao de um resultado, entao:" : x$ = ucase$(input$(1))
  if x$ = "V" then exit sub else if x$ = "A" then goto pagina1
  pagina3:
  call MolduraInf(3)
  locate 3,5 : print _
  "   (1) Se o resultado for uma matriz que nao seja a forma de Jordan e"
  locate 4,5 : print _
  "       for pressionado um G, entao a matriz ser"; chr$(160); " gravada";
  print " no disco  (o" : locate 5,5 : print _
  "       programa perguntar"; chr$(160); " entao o nome da matriz e local";
  print " em que  ela" : locate 6,5 : print _
  "       ser"; chr$(160); " gravada); se for pressionado um # ( ou seja, ";
  print "<Shift><3> )" : locate 7,5 : print _
  "       entao a matriz-resultado passar"; chr$(160); " a ser a  matriz-";
  print "proposta  ( A" : locate 8,5 : print _
  "       'matriz-proposta' "; chr$(130); " a matriz fornecida pelo usu";
  print chr$(160);"rio )." : locate 10,5 : print _
  "   (2) Se o resultado for o polin"; chr$(147); "mio caracter"; chr$(161);
  print "stico e for pressiona-" : locate 11,5 : print _
  "       do um F entao o polin"; chr$(147); "mio ser"; chr$(160);
  print " fatorado; se for pressionado um" : locate 12,5 : print _
  "       G entao os coeficientes do polin"; chr$(147); "mio serao gravados";
  print " em um  ar-" : locate 13,5 : print _
  "       quivo chamado POLINOM.CAR e  da"; chr$(161);" ele poder"; chr$(160);
  print " ser recuperado  ao" : locate 14,5 : print _
  "       t"; chr$(130); "rmino do programa ( se ele for gravado em A, bastar";
  print chr$(160); " o usu"; chr$(160); "-"
  locate 15,5 : print "       rio digitar:   A> TYPE POLINOM.CAR )"
  locate 17,5 : print _
  "   (3) Se o resultado forem os autovalores e for digitado um G, entao"
  locate 18,5 : print _
  "       os autovalores serao gravados no arquivo AUTOVALO.RES  de onde"
  locate 19,5 : print _
  "       poderao ser  recuperados pelo comando TYPE do MS-DOS."
  x$ = ucase$(input$(1))
  if x$ = "V" then exit sub else if x$ = "A" then goto pagina2
  pagina4:
  call MolduraInf(4)
  locate 3,5 : print _
  "   (4) Se for digitado um I ap"; chr$(162); "s qualquer  apresentacao de";
  print " resultados," : locate 4,5 : print _
  "       entao o resultado ser"; chr$(160); " enviado para a impressora."
  locate 6,5 : print " "; chr$(16); " Grava"; chr$(135); "ao dos resultados";
  print " em disco:" : locate 8,5 : print _
  "      Internamente  a maioria  dos  c"; chr$(160); "lculos  sao feitos com";
  print " 16  casas" : locate 9,5 : print _
  " decimais. Na tela sao mostradas no m"; chr$(160); "ximo  4 decimais.";
  print " Gravando-se no" : locate 10,5 : print _
  " disco, pode-se observar os resultados com todas as casas decimais, a-"
  locate 11,5 : print _
  " l"; chr$(130); "m de evitar o uso desnecess"; chr$(160); "rio de papel."
  locate 13,5 : print _
  " "; chr$(16); " Autovalores, autovetores e a forma de Jordan:"
  locate 15,5 : print _
  "      Os autovetores associados a autovalores complexos nao sao calcu-"
  locate 16,5 : print _
  " lados, mas, o programa avisa se eles existirem. Neste caso a forma de"
  locate 17,5 : print _
  " Jordan apresentar"; chr$(160); " a + bi, a - bi,  etc. na diagonal";
  print " principal.  Para" : locate 18,5 : print _
  " cada  autovalor  real "; chr$(130); "  fornecida  uma  base do  autoespa";
  print chr$(135); "o associa-" : locate 19,5 : print _
  " do. Lembre-se de que, por exemplo, o espa"; chr$(135);"o gerado por  (-1,";
  print " 0, -1) "; chr$(130) : locate 20,5 : print " o mesmo que o gerado por ";
  print "(2, 0, 2) ." : x$ = ucase$(input$(1))
  if x$ = "V" then exit sub else if x$ = "A" then goto pagina3
  pagina5:
  call MolduraInf(5)
  locate 3,5 : print " "; chr$(16); " Matrizes semelhantes:"
  locate 4,5 : print "                -1"
  locate 5,5 : print _
  "      A op"; chr$(135); "ao  P  MP  do menu permite obter matrizes semelh";
  print "antes a  M," : locate 6,5 : print _
  " bastando para isso que seja fornecida uma matriz P  invers"; chr$(161);
  print "vel.  Essa" : locate 7,5 : print _
  " op"; chr$(135); "ao "; chr$(130); " bastante "; chr$(163); "til para se ";
  print "construir problemas com resultados pr"; chr$(130); "-"
  locate 8,5 : print " definidos.
  locate 10,5 : print " "; chr$(16); " Composi"; chr$(135); "ao de v";
  print chr$(160); "rios "; chr$(161); "tens dos menus:" : locate 12,5 : print_
  "      Dada uma matriz M, podemos obter facilmente a matriz inversa de"
  locate 13,5 : print _
  " M elevada a 5 , o  polin"; chr$(147); "mio  caracter"; chr$(161); "stico";
  print " do  quadrado de  M, etc." : locate 14,5 : print _
  " Para se fazer isso basta digitar  #  em cada resultado intermedi";
  print chr$(160); "rio." : locate 15,5 : print _
  " Por exemplo, para se calcular a  forma de Jordan de  M  elevado a  4,"
  locate 16,5 : print _
  " basta digitar    <1><0>   <4><ENTER>   <Shift><3>   <1><1> ."
  locate 18,5 : print " "; chr$(16); " Como encerrar o programa:"
  locate 20,5 : print _
  "      Se estiver na tela um  dos menus, entao  basta digitar as teclas"
  x$ = ucase$(input$(1))
  if x$ = "V" then exit sub else if x$ = "A" then goto pagina4
  pagina6:
  call MolduraInf(6)
  locate 3,5 : print _
  " num"; chr$(130); "ricas que correspondam "; chr$(133);" op"; chr$(135);
  print "ao 'Fim'. Em outras partes do progra-"
  locate 4,5 : print " ma, deve-se pressionar <Ctrl><Break>."
  locate 6,5 : print " "; chr$(16); " Erros nas aproxima"; chr$(135); "oes:"
  locate 8,5 : print _
  "      Usam-se tres erros diferentes no programa: erro1 = 0.0001 (usado"
  locate 9,5 : print _
  " na aproxima"; chr$(135); "ao de autovalores para inteiros),  erro2  = ";
  print " 0.0000000001" : locate 10,5 : print _
  " ( usado no c"; chr$(160); "lculo dos autovalores )  e  erro3 = 0.000001";
  print "  ( usado no" : locate 11,5 : print _
  " escalonamento de matrizes e no c"; chr$(160); "lculo do polin"; chr$(147);
  print "mio m"; chr$(161); "nimo ) . O usu-" : locate 12,5 : print _
  " "; chr$(160); "rio  pode alterar "; chr$(133); " vontade o valor desses";
  print " erros, bastando para isso" : locate 13,5 : print _
  " digitar um E quando aparecer  a primeira  tela do programa  ('ALGEBRA"
  locate 14,5 : print _
  " LINEAR COMPUTACIONAL'). Nao "; chr$(130); " conveniente deixar esses";
  print " erros pequenos" : locate 15,5 : print _
  " demais ( da ordem de 10 elevado a  -12 ou menores ) pois nesses casos"
  locate 16,5 : print _
  " o programa pode entrar em la"; chr$(135); "os e nao poder sair depois."
  locate 17,5 : print _
  "      A seguir temos o exemplo de uma  matriz que se o erro1 for dimi-"
  locate 18,5 : print _
  " nu"; chr$(161); "do para 0.000000001, entao os autovalores  encontrados";
  print " serao 2, 2," : locate 19,5 : print _
  " 2.9999, 3 + 0.0001 i  e  3 - 0.0001 i  nao serao aproximados  para os"
  locate 20,5 : print _
  " verdadeiros valores que sao 2, 2, 3, 3, 3. Se voce usar o  erro1 pr";
  print  chr$(130); "-" : x$ = ucase$(input$(1))
  if x$ = "V" then exit sub else if x$ = "A" then goto pagina5
  pagina7:
  call MolduraInf(7)
  locate 3,5 : print _
  " definido no programa (ou um valor maior como  0.001) entao os valores"
  locate 4,5 : print " verdadeiros serao encontrados."
  locate 7,23 : print " 32/13    -3/13     0    0    -1/13"
  locate 9,23 : print "-12/13    32/13     0    0     2/13"
  locate 11,23 : print " -7/39    -1/13     3    0    -1/39"
  locate 13,23 : print "-43/13   -24/13     0    3     5/13"
  locate 15,23 : print " -6/13     3/13     0    0    27/13"
  locate 18,5 : print _
  "      O polin"; chr$(147); "mio m"; chr$(161); "nimo desta matriz ";
  print chr$(130); "  m(x)  =  (x - 2)(x - 3)  e  o" : locate 19,5 : print _
  " polin"; chr$(147); "mio caracter"; chr$(161); "stico ";
  print  chr$(130); "                2       3" : locate 20,5 : print _
  "                             p(x) = (x - 2) (x - 3) . "
  x$ = ucase$(input$(1))
  if x$ = "V" then exit sub else if x$ = "A" then goto pagina6
  goto pagina1
end sub

end

'     ========================= FIM DO PROGRAMA ==============================
